;
; CvOppb`
;

	relaxed on

KEYDATA		equ	$e224	; L[̓obt@
GAMEDATA	equ	$e225	; Q[L[̓obt@
TABDAT		equ	$e226	; TAB
MODEDAT		equ	$e227	; MODE

Disk_Load	equ	$e303

CHRBUF		equ	$e600	; L`pobt@/eLXgVRAMobt@
SPPTDAT		equ	$e200	; ʏ펞̃X^bN|C^

WINDBUF		equ	$9000	; EChpobt@
MAGICBUFLIST	equ	$8000	; @epobt@Xgi0xc000`j
MAGICBUF	equ	$8100	; @epobt@i0xc100`j

; 0x0100`0x0251
; ݒ
; 炷
;
	org	$0100

	ld	sp,SPPTDAT
	call	$076c		; OFF

PLAY_START:
	ld	a,(MODEDAT)
	or	a
	jp	z,$07d9


	xor	a		; 0x0000-0x1FFF݂̏RAM
	out	($68),a	
	add	a,2		; 0x2000-0x3FFF݂̏RAM
	out	($69),a	
	add	a,2		; 0x4000-0x5FFF݂̏RAM
	out	($6a),a	
	add	a,2		; 0x6000-0x7FFF݂̏RAM
	out	($6b),a	
	add	a,2		; 0x8000-0x9FFF݂̏RAM
	out	($6c),a	
	add	a,2		; 0xA000-0xBFFF݂̏RAM
	out	($6d),a	
	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a

;
; START.DAT[h
;
	ld	de,$3201	; DregFgbNԍAEregFZN^ԍ
	ld	bc,$c000	; BregFZN^ACregFhCuԍ
	ld	hl,$0000	; i[擪AhX
	call	Disk_Load


	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a
	ld	a,$20		; 0x0000-0x1FFF݂̏ORAM
	out	($68),a	
	add	a,2		; 0x2000-0x3FFF݂̏ORAM
	out	($69),a	
	add	a,2		; 0x4000-0x5FFF݂̏ORAM
	out	($6a),a	
	add	a,2		; 0x6000-0x7FFF݂̏ORAM
	out	($6b),a	
	add	a,2		; 0x8000-0x9FFF݂̏ORAM
	out	($6c),a	
	add	a,2		; 0xA000-0xBFFF݂̏ORAM
	out	($6d),a	

	ld	a,(MODEDAT)
	or	a
	jp	z,$07d9


	di

	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a

	ld	c,$00

.lp4:
	ld	a,c		; 0xC000-0xDFFF̓ǂݏRAM
	out	($66),a	
	out	($6e),a	
	inc	c
	inc	c
	ld	a,c		; 0xE000-0xFFFF̓ǂݏRAM
	out	($67),a	
	out	($6f),a	
	inc	c
	inc	c

	ld	hl,$c000
.lp3:
	ld	b,8
.lp2:
	ld	a,$08
	out	($a0),a
	rrc	(hl)
	jp	c,.son
.soff:
	ld	a,$00
	out	($a1),a
	jp	.send
.son:
	ld	a,$0f
	out	($a1),a
.send:

	djnz	.lp2
	inc	hl

	ld	a,h
	or	a
	jr	nz,.lp3

	ld	a,c
	cp	$0c
	jr	nz,.lp4


	ld	a,$2c		; 0xC000-0xFFFF̓ǂݏRAM
	out	($66),a	
	out	($6e),a	
	add	a,2		; 0xE000-0xFFFF̓ǂݏRAM
	out	($67),a	
	out	($6f),a	

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ei

	jp	$0252

;
; 炷i"L"ój
;
PLAY_L:
	di
	ld	a,$08
	out	($a0),a
	ld	a,$00
	out	($a1),a
	ei
	ret

;
; 炷i"H"ój
;
PLAY_H:
	di
	ld	a,$08
	out	($a0),a
	ld	a,(MODEDAT)
	out	($a1),a
	ei
	ret

;
; SPACEL[́iQ[X^[gj
; Zflag=1FX^[g
;
WAITSPC:
	push	bc

	ld	a,(GAMEDATA)
	ld	c,a
	ld	a,(BUFGAMEDATA)
	cpl
	or	c			; GAMEDATA=0 and BUFGAMEDATA=1 Ȃ 0

	bit	4,a			; SPACE
	jr	nz,.end
	ld	c,$00
.end:
	ld	a,c
	ld	(BUFGAMEDATA),a

	pop	bc
	ret


BUFGAMEDATA:
	db	$00

;
; STOPL[́iUԂj
;
STOPCHK:
	push	hl
	ld	hl,GAMEDATA

	di
	bit	6,(hl)		; STOP
	res	6,(hl)		; STOP
	ei

	pop	hl

	call	nz,$5075
	ret

;
; f[^ُ̏
;
TRAP_SUB:
	call	GRCLR
	call	SCON
	ld	a,$41
	ld	($beac),a
	ld	hl,$0111
	ld	($bead),hl
	ld	($18d9),hl
	ret

;
; 񕜖Tu
; F1`F3L[HĂꍇAZflag=0
;
IS_F13:
	rst	$08
	cp	$f0		; F1
	ret	z
	cp	$f1		; F2
	ret	z
	cp	$f2		; F3
	ret



; 0x0252`
; ̂܂܎gp
;
	org	$0252
	db	$ff

; 0x057c`0x057c
; bZ[WύX
;
	org	$057c
	db	$00

; 0x057d`
; ̂܂܎gp
;
	org	$057d
	db	$ff

; 0x06e0`0x06e4
; bZ[WύX
;
	org	$06e0
	db	"SPC>."

; 0x06e5`
; ̂܂܎gp
;
	org	$06e5
	db	$ff

; 0x076c`0x0785
; OFF
;
	org	$076c
SCOFF:
	ld	a,$07
	out	($40),a		; pbgݒi"11"=j
	out	($41),a		; pbgݒi"10"=/Fj
	out	($42),a		; pbgݒi"01"=ԁj
	out	($43),a		; pbgݒi"00"=j
	ld	a,$02
	out	($93),a		; ʂ\Ȃ

	ret


; 0x0786`0x07a7
; ON
;
	org	$0786
SCON:
	call	PALETSET
	ld	a,$03
	out	($93),a		; ʂ\
	ret

;
; pbgݒ
;
PALETSET:
	ld	a,$00
	out	($40),a		; pbgݒi"11"=j
	ld	a,$06
	out	($41),a		; pbgݒi"10"=j
;	ld	a,$0a
;	out	($41),a		; pbgݒi"10"=Fj
	ld	a,$05
	out	($42),a		; pbgݒi"01"=ԁj
	ld	a,$07
	out	($43),a		; pbgݒi"00"=j
	ret


; 0x07a8`0x07d8
; ʃNA
;
	org	$07a8
GRCLR:
	call	WVRAM

	ld	hl,$0000
.lp1:	ld	(hl),$00
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

	call	WMRAM

	ret


; 0x07d9`0x07f1
; Q[Jn
;
	org	$07d9
	jp	$07f2

; 0x07f2`
; ̂܂܎gp
;
	org	$07f2
	db	$ff

; 0x099d`0x09a0
; SPACEL[͑҂
;
	org	$099d
	rst	$10
	cpl
	bit	4,a		; SPACE

; 0x09a1`
; ̂܂܎gp
;
	org	$09a1
	db	$ff

; 0x09ad`0x09af
; X^bN|C^ύX
;
	org	$09ad
	ld	sp,SPPTDAT

; 0x09b0`
; ̂܂܎gp
;
	org	$09b0
	db	$ff

; 0x09bc`0x09d5
; NʊJn
;
	org	$09bc
	jr	$09d6

; 0x09d6`
; ̂܂܎gp
;
	org	$09d6
	db	$ff

; 0x0b0c`0x0b0f
; NʊJñL[
;
	org	$0b0c
	rst	$08
	nop
	cp	'S'		; Z[u

; 0x0b10`
; ̂܂܎gp
;
	org	$0b10
	db	$ff

; 0x0b13`0x0b16
; NʊJñL[
;
	org	$0b13
	rst	$08
	nop
	cp	'L'		; [h

; 0x0b17`
; ̂܂܎gp
;
	org	$0b17
	db	$ff

; 0x0b1a`0x0b1d
; NʊJñL[
;
	org	$0b1a
	rst	$08
	nop
	cp	'G'		; X^[g

; 0x0b1e`
; ̂܂܎gp
;
	org	$0b1e
	db	$ff

; 0x0b21`0x0b24
; NʊJñL[
;
	org	$0b21
	nop
	call	WAITSPC

; 0x0b25`
; ̂܂܎gp
;
	org	$0b25
	db	$ff

; 0x0b2b`0x0b2d
; ~߂
;
	org	$0b2b
	call	PLAY_L

; 0x0b2e`
; ̂܂܎gp
;
	org	$0b2e
	db	$ff

; 0x0b6c`0x0b6f
; [h
;
	org	$0b6c
	rst	$08
	nop
	cp	$f0		; F1

; 0x0b70`
; ̂܂܎gp
;
	org	$0b70
	db	$ff

; 0x0b73`0x0b74
; [h
;
	org	$0b73
	cp	$f1		; F2

; 0x0b75`
; ̂܂܎gp
;
	org	$0b75
	db	$ff

; 0x0b78`0x0b79
; [h
;
	org	$0b78
	cp	$f2		; F3

; 0x0b7a`
; ̂܂܎gp
;
	org	$0b7a
	db	$ff

; 0x0b7d`0x0b7e
; [h
;
	org	$0b7d
	cp	$f3		; F4

; 0x0b7f`
; ̂܂܎gp
;
	org	$0b7f
	db	$ff

; 0x0b82`0x0b83
; [h
;
	org	$0b82
	cp	$f4		; F5

; 0x0b84`
; ̂܂܎gp
;
	org	$0b84
	db	$ff

; 0x0bb0`0x0bb0
; 荞݋֎~O
;
	org	$0bb0
	nop

; 0x0bb1`
; ̂܂܎gp
;
	org	$0bb1
	db	$ff

; 0x0bb9`0x0bb9
; 荞݋֎~O
;
	org	$0bb9
	nop

; 0x0bba`
; ̂܂܎gp
;
	org	$0bba
	db	$ff

; 0x0bd1`0x0bd1
; 荞݋֎~O
;
	org	$0bd1
	nop

; 0x0bd2`
; ̂܂܎gp
;
	org	$0bd2
	db	$ff

; 0x0bf2`0x0bf5
; Z[u
;
	org	$0bf2
	rst	$08
	nop
	cp	$f0		; F1

; 0x0bf6`
; ̂܂܎gp
;
	org	$0bf6
	db	$ff

; 0x0bf9`0x0bfa
; Z[u
;
	org	$0bf9
	cp	$f1		; F2

; 0x0bfb`
; ̂܂܎gp
;
	org	$0bfb
	db	$ff

; 0x0bfe`0x0bff
; Z[u
;
	org	$0bfe
	cp	$f2		; F3

; 0x0c00`
; ̂܂܎gp
;
	org	$0c00
	db	$ff

; 0x0c03`0x0c04
; Z[u
;
	org	$0c03
	cp	$f3		; F4

; 0x0c05`
; ̂܂܎gp
;
	org	$0c05
	db	$ff

; 0x0c08`0x0c09
; Z[u
;
	org	$0c08
	cp	$f4		; F5

; 0x0c0a`
; ̂܂܎gp
;
	org	$0c0a
	db	$ff

; 0x0c36`0x0c36
; 荞݋֎~O
;
	org	$0c36
	nop

; 0x0c37`
; ̂܂܎gp
;
	org	$0c37
	db	$ff

; 0x0c3f`0x0c3f
; 荞݋֎~O
;
	org	$0c3f
	nop

; 0x0c40`
; ̂܂܎gp
;
	org	$0c40
	db	$ff

; 0x0c57`0x0c57
; 荞݋֎~O
;
	org	$0c57
	nop

; 0x0c58`
; ̂܂܎gp
;
	org	$0c58
	db	$ff

; 0x0c65`0x0c65
; 荞݋֎~O
;
	org	$0c65
	nop

; 0x0c66`
; ̂܂܎gp
;
	org	$0c66
	db	$ff

; 0x0c6e`0x0c70
; X^bN|C^ύX
;
	org	$0c6e
	ld	sp,SPPTDAT

; 0x0c71`
; ̂܂܎gp
;
	org	$0c71
	db	$ff

; 0x0c86`0x0c86
; 荞݋֎~O
;
	org	$0c86
	nop

; 0x0c87`
; ̂܂܎gp
;
	org	$0c87
	db	$ff

; 0x0cb5`0x0cb5
; 荞݋֎~O
;
	org	$0cb5
	nop

; 0x0cb6`
; ̂܂܎gp
;
	org	$0cb6
	db	$ff

; 0x0cd1`0x0cd1
; 荞݋֎~O
;
	org	$0cd1
	nop

; 0x0cd2`
; ̂܂܎gp
;
	org	$0cd2
	db	$ff

; 0x0ced`0x0ced
; 荞݋֎~O
;
	org	$0ced
	nop

; 0x0cee`
; ̂܂܎gp
;
	org	$0cee
	db	$ff

; 0x0d09`0x0d09
; 荞݋֎~O
;
	org	$0d09
	nop

; 0x0d0a`
; ̂܂܎gp
;
	org	$0d0a
	db	$ff

; 0x0d25`0x0d25
; 荞݋֎~O
;
	org	$0d25
	nop

; 0x0d26`
; ̂܂܎gp
;
	org	$0d26
	db	$ff

; 0x0d64`0x0d66
; X^bN|C^ύX
;
	org	$0d64
	ld	sp,SPPTDAT

; 0x0d67`
; ̂܂܎gp
;
	org	$0d67
	db	$ff

; 0x0d7c`0x0d7c
; 荞݋֎~O
;
	org	$0d7c
	nop

; 0x0d7d`
; ̂܂܎gp
;
	org	$0d7d
	db	$ff

; 0x0f17`0x0f17
; 荞݋֎~O
;
	org	$0f17
	nop

; 0x0f18`
; ̂܂܎gp
;
	org	$0f18
	db	$ff

; 0x0f41`0x0f41
; 荞݋֎~O
;
	org	$0f41
	nop

; 0x0f42`
; ̂܂܎gp
;
	org	$0f42
	db	$ff

; 0x10dc`0x10dc
; 荞݋֎~O
;
	org	$10dc
	nop

; 0x10dd`
; ̂܂܎gp
;
	org	$10dd
	db	$ff

; 0x1106`0x1106
; 荞݋֎~O
;
	org	$1106
	nop

; 0x1107`
; ̂܂܎gp
;
	org	$1107
	db	$ff

; 0x12a1`0x12a1
; 荞݋֎~O
;
	org	$12a1
	nop

; 0x12a2`
; ̂܂܎gp
;
	org	$12a2
	db	$ff

; 0x12cb`0x12cb
; 荞݋֎~O
;
	org	$12cb
	nop

; 0x12cc`
; ̂܂܎gp
;
	org	$12cc
	db	$ff

; 0x1466`0x1466
; 荞݋֎~O
;
	org	$1466
	nop

; 0x1467`
; ̂܂܎gp
;
	org	$1467
	db	$ff

; 0x1490`0x1490
; 荞݋֎~O
;
	org	$1490
	nop

; 0x1491`
; ̂܂܎gp
;
	org	$1491
	db	$ff

; 0x162b`0x162b
; 荞݋֎~O
;
	org	$162b
	nop

; 0x162c`
; ̂܂܎gp
;
	org	$162c
	db	$ff

; 0x164c`0x1659
; pbgݒ
;
	org	$164c
	jr	$165a

; 0x165a`
; ̂܂܎gp
;
	org	$165a
	db	$ff

; 0x18a9`0x18b7
; ʃf[^ُ̏ꍇ
;
	org	$18a9
	call	TRAP_SUB
	jp	$18b8

; 0x18b8`
; ̂܂܎gp
;
	org	$18b8
	db	$ff

; 0x18e7`0x18ea
; 荞݋֎~O
; X^bN|C^ύX
;
	org	$18e7
	nop
	ld	sp,SPPTDAT

; 0x18eb`
; ̂܂܎gp
;
	org	$18eb
	db	$ff

; 0x19f5`0x19f7
; @epobt@NA
;
	org	$19f5
	call	MAGICBUFCLR

; 0x19f8`0x19fb
; ~߂
;
	org	$19f8
	call	PLAY_L
	nop

; 0x19fc`
; ̂܂܎gp
;
	org	$19fc
	db	$ff

; 0x1a82`0x1a88
; 񕜖gp
;
	org	$1a82
	call	IS_F13
	nop
	jp	nz,$1aa7

; 0x1a89`
; ̂܂܎gp
;
	org	$1a89
	db	$ff

; 0x1a96`0x1a99
; 񕜖gp
;
	org	$1a96
	rst	$08
	nop
	cp	$f0		; F1

; 0x1a9a`
; ̂܂܎gp
;
	org	$1a9a
	db	$ff

; 0x1a9d`0x1a9e
; 񕜖gp
;
	org	$1a9d
	cp	$f1		; F2

; 0x1a9f`
; ̂܂܎gp
;
	org	$1a9f
	db	$ff

; 0x1aa2`0x1aa3
; 񕜖gp
;
	org	$1aa2
	cp	$f2		; F3

; 0x1aa4`
; ̂܂܎gp
;
	org	$1aa4
	db	$ff

; 0x1aab`0x1aae
; o^܂
;
	org	$1aab
	ld	a,(TABDAT)
	or	a

; 0x1aaf`
; ̂܂܎gp
;
	org	$1aaf
	db	$ff

; 0x1ae8`0x1aeb
; \
;
	org	$1ae8
	rst	$08
	nop
	cp	'I'		; \

; 0x1aec`
; ̂܂܎gp
;
	org	$1aec
	db	$ff

; 0x1af2`0x1af5
; @I
;
	org	$1af2
	rst	$10
	cpl
	bit	5,a		; @IiSHIFTj

; 0x1af6`
; ̂܂܎gp
;
	org	$1af6
	db	$ff

; 0x1c0b`0x1c0e
; @s
;
	org	$1c0b
	rst	$10
	cpl
	bit	4,a		; @siSPACEj

; 0x1c0f`
; ̂܂܎gp
;
	org	$1c0f
	db	$ff

; 0x1c45`0x1c48
; ړL[
;
	org	$1c45
	rst	$10
	cpl
	bit	1,a		; 

; 0x1c49`
; ̂܂܎gp
;
	org	$1c49
	db	$ff

; 0x1c4c`0x1c4f
; ړL[
;
	org	$1c4c
	rst	$10
	cpl
	bit	0,a		; 

; 0x1c50`
; ̂܂܎gp
;
	org	$1c50
	db	$ff

; 0x1c53`0x1c56
; ړL[
;
	org	$1c53
	rst	$10
	cpl
	bit	2,a		; 

; 0x1c57`
; ̂܂܎gp
;
	org	$1c57
	db	$ff

; 0x1c5a`0x1c5b
; ړL[
;
	org	$1c5a
	bit	3,a		; E

; 0x1c5c`
; ̂܂܎gp
;
	org	$1c5c
	db	$ff

; 0x1cf1`0x1cf7
; ꎞ~
;
	org	$1cf1
	rst	$08
	nop
	cp	$1b		; ESC
	call	z,ESCCHK

; 0x1cf8`0x1cfa
; X^bN|C^ύX
;
	org	$1cf8
	ld	sp,SPPTDAT

; 0x1cfb`0x1cfe
; ŗpL[
;
	org	$1cfb
	rst	$08
	nop
	cp	$1a		; CTRL-Z

; 0x1cff`
; ̂܂܎gp
;
	org	$1cff
	db	$ff

; 0x1d02`0x1d08
; UԂ
;
	org	$1d02
	call	STOPCHK
	jp	$1d09

; 0x1d09`
; ̂܂܎gp
;
	org	$1d09
	db	$ff

; 0x3368`0x3371
; ESCꎞ~
;
	org	$3368
ESCCHK:
	xor	a
	ld	(KEYDATA),a
.lp:
	rst	$08
	or	a
	ret	nz
	jr	.lp

; 0x3372`
; ̂܂܎gp
;
	org	$3372
	db	$ff

; 0x33a0`0x33ec
; 32x16L\iXORj
;
	org	$33a0

	push	hl
	ex	de,hl
	ld	de,CHRBUF
	ld	bc,4*16*2
	ldir
	pop	hl
	ld	de,CHRBUF
	ld	a,$ff
	call	DRAW32x16

	ret

; 0x33ed`
; ̂܂܎gp
;
	org	$33ed
	db	$ff

; 0x3422`0x34bf
; 16x8L`
; HLFVRAMAhX
; DEFLN^AhX
;
	org	$3422
	ld	a,3
	call	DRAW16x8
	ret

; 0x34c0`
; ̂܂܎gp
;
	org	$34c0
	db	$ff

; 0x3986`0x3a22
; 16x8L`
; HLFVRAMAhX
; DEFLN^AhX
;
	org	$3986
	ld	a,3
	call	DRAW16x8
	jp	$3a23

; 0x3a23`
; ̂܂܎gp
;
	org	$3a23
	db	$ff

; 0x3e77`0x3e90
; bZ[W̕ύX
;
	org	$3e77
	db	"  ޼ ޮ [STOP]"

; 0x3e91`
; ̂܂܎gp
;
	org	$3e91
	db	$ff

; 0x41d5`0x41d5
; 荞݋֎~O
;
	org	$41d5
	nop

; 0x41d6`
; ̂܂܎gp
;
	org	$41d6
	db	$ff

; 0x41de`0x41de
; 荞݋֎~O
;
	org	$41de
	nop

; 0x41df`
; ̂܂܎gp
;
	org	$41df
	db	$ff

; 0x41ec`0x41ec
; 荞݋֎~O
;
	org	$41ec
	nop

; 0x41ed`
; ̂܂܎gp
;
	org	$41ed
	db	$ff

; 0x4211`0x4211
; 荞݋֎~O
;
	org	$4211
	nop

; 0x4212`
; ̂܂܎gp
;
	org	$4212
	db	$ff

; 0x421e`0x421e
; 荞݋֎~O
;
	org	$421e
	nop

; 0x421f`
; ̂܂܎gp
;
	org	$421f
	db	$ff

; 0x449b`0x449e
; 炷
;
	org	$449b
	ld	a,(MODEDAT)
	or	a

; 0x449f`
; ̂܂܎gp
;
	org	$449f
	db	$ff

; 0x44d9`0x44df
; 炷i"L"ój
;
	org	$44d9
	call	PLAY_L
	jp	$44e0

; 0x44e0`
; ̂܂܎gp
;
	org	$44e0
	db	$ff

; 0x44ea`0x44f0
; 炷i"L"ój
;
	org	$44ea
	call	PLAY_L
	jp	$44f1

; 0x44f1`
; ̂܂܎gp
;
	org	$44f1
	db	$ff

; 0x44fe`0x4504
; 炷i"H"ój
;
	org	$44fe
	call	PLAY_H
	jp	$4505

; 0x4505`
; ̂܂܎gp
;
	org	$4505
	db	$ff

; 0x450f`0x4515
; 炷i"L"ój
;
	org	$450f
	call	PLAY_L
	jp	$4516

; 0x4516`
; ̂܂܎gp
;
	org	$4516
	db	$ff

; 0x4522`0x4526
; 炷
;
	org	$4522
	jp	PLAY_L

; 0x4527`
; ̂܂܎gp
;
	org	$4527
	db	$ff

; 0x460b`0x460d
; X^bN|C^ύX
;
	org	$460b
	ld	sp,SPPTDAT

; 0x460e`
; ̂܂܎gp
;
	org	$460e
	db	$ff

; 0x4750`0x4762
; \
;
	org	$4750
	call	BUFWINDBOX
	call	DRAWWINDBOX
	call	CLRTXT
	jp	$4763

; 0x4763`0x4766
; \
;
	org	$4763
	ld	ix,CHRBUF+$fc60-$f300

; 0x4767`
; ̂܂܎gp
;
	org	$4767
	db	$ff

; 0x4782`0x4785
; \
;
	org	$4782
	ld	ix,CHRBUF+$fe68-$f300

; 0x4786`
; ̂܂܎gp
;
	org	$4786
	db	$ff

; 0x4821`0x4824
; \
;
	org	$4821
	ld	ix,CHRBUF+$fce1-$f300

; 0x4825`
; ̂܂܎gp
;
	org	$4825
	db	$ff

; 0x4869`0x486c
; \
;
	org	$4869
	ld	ix,CHRBUF+$fd59-$f300

; 0x486d`
; ̂܂܎gp
;
	org	$486d
	db	$ff

; 0x48a6`0x48a9
; \
;
	org	$48a6
	ld	ix,CHRBUF+$fdd1-$f300

; 0x48aa`
; ̂܂܎gp
;
	org	$48aa
	db	$ff

; 0x48d8`0x48db
; \
;
	org	$48d8
	ld	ix,CHRBUF+$fe49-$f300

; 0x48dc`
; ̂܂܎gp
;
	org	$48dc
	db	$ff

; 0x48f1`0x48f4
; \
;
	org	$48f1
	ld	ix,CHRBUF+$fd00-$f300

; 0x48f5`
; ̂܂܎gp
;
	org	$48f5
	db	$ff

; 0x48fe`0x4901
; \
;
	org	$48fe
	ld	ix,CHRBUF+$fd78-$f300

; 0x4902`
; ̂܂܎gp
;
	org	$4902
	db	$ff

; 0x490b`0x490e
; \
;
	org	$490b
	ld	ix,CHRBUF+$fdf0-$f300

; 0x490f`
; ̂܂܎gp
;
	org	$490f
	db	$ff

; 0x4912`0x492b
; \
;
	org	$4912
	call	DISPWIND
	call	WAITRET
	call	DRAWWINDBOX
	call	CLRTXT
	jp	$492c

; 0x492c`0x492f
; \
;
	org	$492c
	ld	ix,CHRBUF+$fe68-$f300

; 0x4930`
; ̂܂܎gp
;
	org	$4930
	db	$ff

; 0x49a2`0x49bd
; ʉEChɃbZ[W\
;
	org	$49a2
	call	DISPWIND
	call	WAITRET
	call	DRAWWINDBUF
	ret

; 0x49be`
; ̂܂܎gp
;
	org	$49be
	db	$ff

; 0x4c61`0x4c64
; oĂH
;
	org	$4c61
	ld	a,(TABDAT)
	or	a

; 0x4c65`
; ̂܂܎gp
;
	org	$4c65
	db	$ff

; 0x4cdd`0x4ce0
; oĂH
;
	org	$4cdd
	ld	a,(TABDAT)
	or	a

; 0x4ce1`
; ̂܂܎gp
;
	org	$4ce1
	db	$ff

; 0x4d59`0x4d5c
; oĂH
;
	org	$4d59
	ld	a,(TABDAT)
	or	a

; 0x4d5d`
; ̂܂܎gp
;
	org	$4d5d
	db	$ff

; 0x4dd5`0x4dd8
; oĂH
;
	org	$4dd5
	ld	a,(TABDAT)
	or	a

; 0x4dd9`
; ̂܂܎gp
;
	org	$4dd9
	db	$ff

; 0x4e51`0x4e54
; oĂH
;
	org	$4e51
	ld	a,(TABDAT)
	or	a

; 0x4e55`
; ̂܂܎gp
;
	org	$4d55
	db	$ff

; 0x5075`0x5078
; oĂH
;
	org	$5075
	ld	a,(TABDAT)
	or	a

; 0x5079`
; ̂܂܎gp
;
	org	$5079
	db	$ff

; 0x5152`0x5172
; 32x16ۑi16x8Pʁj
; ɂPv[32x16̃LORŕ`iFj
; `32x16ۑi16x8Pʁj
;
; HLF88pVRAMAhX
; DEFp^[AhX
;
	org	$5152
DRAW_PG:

	ld	a,$00		; 
	call	BUFMAGIC_32x16

	push	hl
	push	hl
	ex	de,hl
	ld	de,CHRBUF
	ld	bc,4*16
	ldir
	pop	hl
	ld	de,CHRBUF
.mode:	ld	a,$fe		; FPv[
	call	DRAW32x16
	pop	hl

	ld	a,$01		; 
	call	BUFMAGIC_32x16

	ret

; 0x5173`0x518a
; ۑ32x16߂
; HLF88pVRAMAhX
;
	org	$5173
	call	DRAWBUFMAGIC_32x16
	ret

; 0x518b`
; ̂܂܎gp
;
	org	$518b
	db	$ff

; 0x51a2`0x51c6
; FLASH
;
	org	$51a2
FLASH_PALET:
	or	$08
	out	($43),a
	ld	b,0
.lp1:
	push	hl
	pop	hl
	push	hl
	pop	hl
	djnz	.lp1
	jp	$51c7

; 0x51c7`
; ̂܂܎gp
;
	org	$51c7
	db	$ff

; 0x51da`0x51f2
; FLASH
;
	org	$51da
	call	PALETSET
	jp	$51f3

; 0x51f3`
; ̂܂܎gp
;
	org	$51f3
	db	$ff

; 0x52fc`0x52ff
; METEO
;
	org	$52fc
	rst	$10
	cpl
	bit	2,a		; 

; 0x5300`
; ̂܂܎gp
;
	org	$5300
	db	$ff

; 0x5303`0x5304
; METEO
;
	org	$5303
	bit	3,a		; E

; 0x5305`
; ̂܂܎gp
;
	org	$5305
	db	$ff

; 0x533f`0x5342
; WIND
;
	org	$533f
	rst	$10
	cpl
	bit	2,a		; 

; 0x5343`
; ̂܂܎gp
;
	org	$5343
	db	$ff

; 0x5346`0x5347
; WIND
;
	org	$5346
	bit	3,a		; E

; 0x5348`
; ̂܂܎gp
;
	org	$5348
	db	$ff

; 0x5382`0x5385
; VOLT
;
	org	$5382
	rst	$10
	cpl
	bit	2,a		; 

; 0x5386`
; ̂܂܎gp
;
	org	$5386
	db	$ff

; 0x5389`0x538a
; VOLT
;
	org	$5389
	bit	3,a		; E

; 0x538b`
; ̂܂܎gp
;
	org	$538b
	db	$ff

; 0x53c5`0x53e6
; BEAM
;
	org	$53c5
	call	BEAMDRAW
	jp	$53e7

; 0x53e7`
; ̂܂܎gp
;
	org	$53e7
	db	$ff

; 0x53f4`0x540d
; BEAM
;
	org	$53f4
BEAM_PALET:
	or	$08
	out	($40),a
	xor	a
.lp1:
	push	hl
	pop	hl
	push	hl
	pop	hl
	dec	a
	djnz	.lp1

	pop	af
	dec	a
	jp	nz,$53e9

	call	PALETSET
	call	ERASEBEAM
	jp	$540e

; 0x540e`
; ̂܂܎gp
;
	org	$540e
	db	$ff

; 0x5884`0x5886
; SHOCK
;
	org	$5884
	call	DRAW_PG

; 0x5887`
; ̂܂܎gp
;
	org	$5887
	db	$ff

; 0x5899`0x589b
; SHOCK
;
	org	$5899
	call	DRAW_PG

; 0x589c`
; ̂܂܎gp
;
	org	$589c
	db	$ff

; 0x58ae`0x58b0
; SHOCK
;
	org	$58ae
	call	DRAW_PG

; 0x58b1`
; ̂܂܎gp
;
	org	$58b1
	db	$ff

; 0x58c3`0x58c5
; SHOCK
;
	org	$58c3
	call	DRAW_PG

; 0x58c6`
; ̂܂܎gp
;
	org	$58c6
	db	$ff

; 0x58d8`0x58da
; SHOCK
;
	org	$58d8
	call	DRAW_PG

; 0x58db`
; ̂܂܎gp
;
	org	$58db
	db	$ff

; 0x58e7`0x58f7
; SHOCK
;
	org	$58e7
SHOCK_PALET:
	or	$08
	out	($40),a
	ld	b,0
.lp1:
	push	hl
	pop	hl
	push	hl
	pop	hl
	djnz	.lp1
	jp	$58f8

; 0x58f8`
; ̂܂܎gp
;
	org	$58f8
	db	$ff

; 0x590b`0x592c
; SHOCK
;
	org	$590b
	call	ERASESHOCK
	call	PALETSET
	jp	$592d

; 0x592d`
; ̂܂܎gp
;
	org	$592d
	db	$ff

; 0x665e`0x6670
; ʉEChɃbZ[W\
;
	org	$665e
	call	BUFWINDBOX
	call	DRAWWINDBOX
	call	CLRTXT
	jp	$6671

; 0x6671`0x6674
; ʉEChɃbZ[W\
;
	org	$6671
	ld	ix,CHRBUF+$fc60-$f300

; 0x6675`
; ̂܂܎gp
;
	org	$6675
	db	$ff

; 0x668d`0x6690
; ʉEChɃbZ[W\
;
	org	$668d
	ld	ix,CHRBUF+$fe68-$f300

; 0x6691`
; ̂܂܎gp
;
	org	$6691
	db	$ff

; 0x669f`0x66ba
; ʉEChɃbZ[W\
;
	org	$669f
	call	DISPWIND
	call	WAITRET
	call	DRAWWINDBUF
	ret

; 0x66bb`
; ̂܂܎gp
;
	org	$66bb
	db	$ff

; 0x66cf`0x66e7
; eLXgVRAMNA
;
	org	$66cf
	call	CLRTXT
	call	CLRTXTVRAM
	ret

; 0x66e8`0x6711
; v[BARigpj
;
	org	$66e8
	jr	$

; 0x6712`0x6743
; v[G
; XYVRAMAhXZo{32x16obt@ǂݏo
;
	org	$6712
	call	$338b
	call	DRAWBUFMAGIC_32x16
	ret

ERASEBREATH:
	ld	hl,($3175)
	dec	h
	dec	h
	ld	($317d),hl
.lp1:
	ld	bc,($317d)
	call	$6712
	ld	a,($317e)
	dec	a
	ld	($317e),a
	ret	z
	jr	.lp1



; 0x6744`0x6764
; EChp``悷igpȂj
;
	org	$6744
	jr	$

; 0x6765`0x67dc
; 摜[hݒ
;
	org	$6765
	ret

; 0x67dd`
; ̂܂܎gp
;
	org	$67dd
	db	$ff

; 0x67f0`0x67f2
; eLXg\
;
	org	$67f0
	ld	de,CHRBUF

; 0x67f3`
; ̂܂܎gp
;
	org	$67f3
	db	$ff

; 0x6899`0x689b
; eLXg\
;
	org	$6899
	ld	de,CHRBUF

; 0x689c`
; ̂܂܎gp
;
	org	$689c
	db	$ff

; 0x6928`0x6934
; 16x8L`
;
	org	$6928
	call	DRAW16x8
	jr	$6935

; 0x6935`
; ̂܂܎gp
;
	org	$6935
	db	$ff

; 0x7453`0x7456
; oĂH
;
	org	$7453
	ld	a,(TABDAT)
	or	a

; 0x7457`
; ̂܂܎gp
;
	org	$7457
	db	$ff

; 0x7da3`0x7da6
; oĂH
;
	org	$7da3
	ld	a,(TABDAT)
	or	a

; 0x7da7`
; ̂܂܎gp
;
	org	$7da7
	db	$ff

; 0x7dd2`0x7dfa
; GL0x0C
;
	org	$7dd2
	ld	a,$06
	out	($40),a		; pbgݒi"11"=j
	ld	a,$06
	out	($41),a		; pbgݒi"10"=j
	ld	a,$06
	out	($42),a		; pbgݒi"01"=ԁj
	ld	a,$07
	out	($43),a		; pbgݒi"00"=j
	jp	$7dfb

; 0x7dfb`
; ̂܂܎gp
;
	org	$7dfb
	db	$ff

; 0x7e0a`0x7e2c
; GL0x0C
;
	org	$7e0a
	call	PALETSET
	jp	$7e2d

; 0x7e2d`
; ̂܂܎gp
;
	org	$7e2d
	db	$ff

; 0x7eb6`0x7eb8
; hS̉
;
	org	$7eb6
	jp	$7eb9

; 0x7eb9`
; ̂܂܎gp
;
	org	$7eb9
	db	$ff

; 0x7ef3`0x7ef8
; hS̉
;
	org	$7ef3
	call	ERASEBREATH
	jp	$7ef9

; 0x7ef9`
; ̂܂܎gp
;
	org	$7ef9
	db	$ff

; 0x7f94`0x7f96
; hS̉
;
	org	$7f94
	jp	$7f97

; 0x7f97`
; ̂܂܎gp
;
	org	$7f97
	db	$ff

; 0x7fd1`0x7fd6
; hS
;
	org	$7fd1
	call	ERASEBREATH
	jp	$7fd7

; 0x7fd7`
; ̂܂܎gp
;
	org	$7fd7
	db	$ff

; 0x803b`0x803e
; SHOCK
;
	org	$803b
	rst	$10		; Q[L[
	nop
	cp	$00

; 0x803f`
; ̂܂܎gp
;
	org	$803f
	db	$ff

; 0x804a`0x8052
; SHOCK
;
	org	$804a
	call	DRAW_PG
	jp	$8053

; 0x8053`
; ̂܂܎gp
;
	org	$8053
	db	$ff

; 0x8059`0x806b
; SHOCK
;
	org	$8059
SHOCK_PALET2:
	or	$08
	out	($40),a
	ld	b,0
.lp1:
	push	hl
	pop	hl
	push	hl
	pop	hl
	djnz	.lp1
	jp	$806c

; 0x806c`
; ̂܂܎gp
;
	org	$806c
	db	$ff

; 0x807f`0x80a0
; SHOCK
;
	org	$807f
	ld	bc,($bead)
	call	$6712
	call	PALETSET
	jp	$80a1

; 0x80a1`
; ̂܂܎gp
;
	org	$80a1
	db	$ff

; 0x9682`0x968f
; 퉮
;
	org	$9682
	jp	$9690

; 0x9690`
; ̂܂܎gp
;
	org	$9690
	db	$ff

; 0x9693`0x9698
; 퉮
;
	org	$9693
	call	TXTON
	jp	$9699

; 0x9699`
; ̂܂܎gp
;
	org	$9699
	db	$ff

; 0x96aa`0x96ac
; 퉮
;
	org	$96aa
	call	DISP_TENKEY

; 0x96ad`
; ̂܂܎gp
;
	org	$96ad
	db	$ff

; 0x9747`0x974c
; 퉮
;
	org	$9747
	call	DISP_WAIT
	call	GRON

; 0x974d`
; ̂܂܎gp
;
	org	$974d
	db	$ff

; 0x9750`0x9753
; 퉮
;
	org	$9750
	jp	$9754

; 0x9754`
; ̂܂܎gp
;
	org	$9754
	db	$ff

; 0x977f`0x9781
; 퉮
;
	org	$977f
	call	DISP_WAIT

; 0x9782`
; ̂܂܎gp
;
	org	$9782
	db	$ff

; 0x9794`0x979e
; eL[
;
	org	$9794
	jp	$979f

; 0x979f`0x97a2
; eL[
;
	org	$979f
	rst	$08
	nop
	cp	'0'

; 0x97a3`
; ̂܂܎gp
;
	org	$97a3
	db	$ff

; 0x97a6`0x97a7
; eL[
;
	org	$97a6
	cp	'1'

; 0x97a8`
; ̂܂܎gp
;
	org	$97a8
	db	$ff

; 0x97ab`0x97ac
; eL[
;
	org	$97ab
	cp	'2'

; 0x97ad`
; ̂܂܎gp
;
	org	$97ad
	db	$ff

; 0x97b0`0x97b1
; eL[
;
	org	$97b0
	cp	'3'

; 0x97b2`
; ̂܂܎gp
;
	org	$97b2
	db	$ff

; 0x97b5`0x97b6
; eL[
;
	org	$97b5
	cp	'4'

; 0x97b7`
; ̂܂܎gp
;
	org	$97b7
	db	$ff

; 0x97ba`0x97bb
; eL[
;
	org	$97ba
	cp	'5'

; 0x97bc`
; ̂܂܎gp
;
	org	$97bc
	db	$ff

; 0x97bf`0x97c0
; eL[
;
	org	$97bf
	cp	'6'

; 0x97c1`
; ̂܂܎gp
;
	org	$97c1
	db	$ff

; 0x97c4`0x97c5
; eL[
;
	org	$97c4
	cp	'7'

; 0x97c6`
; ̂܂܎gp
;
	org	$97c6
	db	$ff

; 0x97c9`0x97cc
; eL[
;
	org	$97c9
	nop
	nop
	cp	'8'

; 0x97cd`
; ̂܂܎gp
;
	org	$97cd
	db	$ff

; 0x97d0`0x97d1
; eL[
;
	org	$97d0
	cp	'9'

; 0x97d2`
; ̂܂܎gp
;
	org	$97d2
	db	$ff

; 0x9812`0x981f
; eL[
;
	org	$9812
	xor	a
	ld	(KEYDATA),a
	jp	$9820

; 0x9820`
; ̂܂܎gp
;
	org	$9820
	db	$ff

; 0x9fa5`0x9fb2
; h
;
	org	$9fa5
	jp	$9fb3

; 0x9fb3`
; ̂܂܎gp
;
	org	$9fb3
	db	$ff

; 0x9fb6`0x9fbf
; h
;
	org	$9fb6
	call	TXTON
	jp	$9fc0

; 0x9fc0`
; ̂܂܎gp
;
	org	$9fc0
	db	$ff

; 0x9fd0`0x9fd2
; h
;
	org	$9fd0
	call	DISP_TENKEY

; 0x9fd3`
; ̂܂܎gp
;
	org	$9fd3
	db	$ff

; 0xa093`0xa095
; h
;
	org	$a093
	call	DISP_WAIT

; 0xa096`
; ̂܂܎gp
;
	org	$a096
	db	$ff

; 0xa82b`0xa838
; 
;
	org	$a82b
	jp	$a839

; 0xa839`
; ̂܂܎gp
;
	org	$a839
	db	$ff

; 0xa83c`0xa841
; 
;
	org	$a83c
	call	TXTON
	jp	$a842

; 0xa842`
; ̂܂܎gp
;
	org	$a842
	db	$ff

; 0xa852`0xa854
; 
;
	org	$a852
	call	DISP_TENKEY

; 0xa855`
; ̂܂܎gp
;
	org	$a855
	db	$ff

; 0xa8eb`0xa8ed
; 
;
	org	$a8eb
	call	DISP_WAIT

; 0xa8ee`
; ̂܂܎gp
;
	org	$a8ee
	db	$ff

; 0xae56`0xae63
; 
;
	org	$ae56
	jp	$ae64

; 0xae64`
; ̂܂܎gp
;
	org	$ae64
	db	$ff

; 0xae67`0xae6c
; 
;
	org	$ae67
	call	TXTON
	jp	$ae6d

; 0xae6d`
; ̂܂܎gp
;
	org	$ae6d
	db	$ff

; 0xae8a`0xae8c
; 
;
	org	$ae8a
	call	DISP_TENKEY

; 0xae8d`
; ̂܂܎gp
;
	org	$ae8d
	db	$ff

; 0xaed9`0xaedf
; 
;
	org	$aed9
	call	DISPTXT
	call	WAITRET
	nop

; 0xaee0`
; ̂܂܎gp
;
	org	$aee0
	db	$ff

; 0xaf0f`0xaf11
; 
;
	org	$af0f
	call	DISP_WAIT

; 0xaf12`
; ̂܂܎gp
;
	org	$af12
	db	$ff

; 0xb62d`0xb63a
; ŉ
;
	org	$b62d
	jp	$b63b

; 0xb63b`
; ̂܂܎gp
;
	org	$b63b
	db	$ff

; 0xb63e`0xb643
; ŉ
;
	org	$b63e
	call	TXTON
	jp	$b644

; 0xb644`
; ̂܂܎gp
;
	org	$bb44
	db	$ff

; 0xb661`0xb663
; ŉ
;
	org	$b661
	call	DISP_TENKEY

; 0xb664`
; ̂܂܎gp
;
	org	$bb64
	db	$ff

; 0xb705`0xb70b
; ŉ
;
	org	$b705
	ld	hl,CHRBUF+$f64e-$f300
	ld	ix,CHRBUF+$f64e-$f300

; 0xb70c`
; ̂܂܎gp
;
	org	$b70c
	db	$ff

; 0xb73a`0xb73b
; ŉ
;
	org	$b73a
	ld	a,$85		; 

; 0xb73c`
; ̂܂܎gp
;
	org	$b73c
	db	$ff

; 0xb73f`0xb745
; eLXgVRAM]
; 炷i"H"ój
;
	org	$b73f
	call	DISPTXT
	call	PLAY_H
	nop

; 0xb746`
; ̂܂܎gp
;
	org	$b746
	db	$ff

; 0xb74f`0xb755
; 炷i"L"ój
;
	org	$b74f
	call	PLAY_L
	jp	$b756

; 0xb756`
; ̂܂܎gp
;
	org	$b756
	db	$ff

; 0xb783`0xb785
; ŉ
;
	org	$b783
	call	DISP_WAIT

; 0xb786`
; ̂܂܎gp
;
	org	$b786
	db	$ff

; 0xb7a3`0xb7a5
; ŉ
;
	org	$b7a3
	call	DISP_WAIT

; 0xb7a6`
; ̂܂܎gp
;
	org	$b7a6
	db	$ff

; 0xbafc`0xbb09
; a@
;
	org	$bafc
	jp	$bb0a

; 0xbb0a`
; ̂܂܎gp
;
	org	$bb0a
	db	$ff

; 0xbb0d`0xbb12
; a@
;
	org	$bb0d
	call	TXTON
	jp	$bb13

; 0xbb13`
; ̂܂܎gp
;
	org	$bb13
	db	$ff

; 0xbb1c`0xbb1e
; a@
;
	org	$bb1c
	call	DISP_TENKEY

; 0xbb1f`
; ̂܂܎gp
;
	org	$bb1f
	db	$ff

; 0xbb69`0xbb6b
; a@
;
	org	$bb69
	call	DISP_WAIT

; 0xbb6c`
; ̂܂܎gp
;
	org	$bb6c
	db	$ff

; 0xbd75`0xbd77
; X^bN|C^ύX
;
	org	$bd75
	ld	sp,SPPTDAT

; 0xbd78`0xbdd0
; ENDING.COMǂݍ
;
	org	$bd78
	ld	de,$1d01	; DregFgbNԍAEregFZN^ԍ
	ld	bc,$2600	; BregFZN^ACregFhCuԍ
	ld	hl,$0100	; i[擪AhX
	call	Disk_Load

	jp	$0100

; 0xbdd1`
; ̂܂܎gp
;
	org	$bdd1
	db	$ff

; 0xbe05`0xbe95
; @`FbNigpj
;
	org	$be05
	ret

; 0xbe96`
; ̂܂܎gp
;
	org	$be96
	db	$ff

; 0xc200`
; ǉvO
;
	org	$c200

; Wve[u
	jp	DRAW32x16	; 0xc200
	jp	DRAW16x8	; 0xc203

;
; VRAM
;
WVRAM:
	push	af
	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a
	xor	a
.cnt:
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a
	pop	af
	ret

;
; ORAM
;
WMRAM:
	push	af
	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a
	ld	a,$20
	jr	WVRAM.cnt

;
; VRAMǂݏ
;
RWVRAM:
	push	af
	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a
	xor	a		; 0x0000-0x7FFF̓ǂݏRAM
.cnt:
	out	($60),a
	out	($68),a
	add	a,2
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	pop	af
	ret

;
; ORAMǂݏ
;
RWMRAM:
	push	af
	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a
	ld	a,$20		; 0x0000-0x7FFF̓ǂݏORAM
	jr	RWVRAM.cnt

;
; 0x8000-0xBFFF̃ANZXύX
;
ACCBANK45:
	out	($64),a
	out	($6c),a
	add	a,2
	out	($65),a
	out	($6d),a
	ret

;
; VRAMAhXZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
; ZflagF1̎
;
;
CALCVRAM:
	bit	6,c
	jp	nz,CALCVRAM_R

CALCVRAM_L:
	push	af
	ld	a,b
	add	a,a
	add	a,$1a
	ld	h,a
	ld	a,c
	add	a,a
	add	a,a
	ld	l,a
	pop	af
	ret

;
; VRAMAhXiEjZo
; BFYWi/8j
; CFXWi/4j
; RETURN
; HLFVRAMAhX
;
CALCVRAM_R:

	push	af

	ld	a,b

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	l,a

	ld	a,c
	add	a,a
	add	a,a
	add	a,l
	ld	l,a

	ld	a,b
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	h,a

	pop	af
	ret

;
; 16x8L`
; HLF88pVRAM
; DEFLN^AhX
; A F`
;
DRAW32x16:
	push	af
	ld	a,4
	ld	(DRAWMxN_L.xsz+1),a
	ld	(DRAWMxN_L.ysz+1),a
	ld	(DRAWMxN_R.xsz+1),a
	ld	(DRAWMxN_R.ysz+1),a
	pop	af

	call	RWVRAM
	call	DRAWMxN
	call	RWMRAM
	ret

;
; 16x8L`
; HLF88pVRAM
; DEFLN^AhX
; A F`
;
DRAW16x8:
	push	af
	ld	a,2
	ld	(DRAWMxN_L.xsz+1),a
	ld	(DRAWMxN_L.ysz+1),a
	ld	(DRAWMxN_R.xsz+1),a
	ld	(DRAWMxN_R.ysz+1),a
	pop	af

	call	WVRAM
	call	DRAWMxN
	call	WMRAM
	ret

;
; MxNL`
; HLF88pVRAM
; DEFLN^AhX
; A F`
;
DRAWMxN:
	push	hl
	push	de
	push	bc

	ld	b,$23		; inc hl

	cp	$01
	jr	nz,.a2
	ld	hl,$2f7e	; ld a,(hl) / cpl
	ld	de,$ff3e	; ld a,$ff
	jr	.start
.a2:
	cp	$02
	jr	nz,.a3
	ld	hl,$ff3e	; ld a,$ff
	ld	de,$2f7e	; ld a,(hl) / cpl
	jr	.start

.a3:
	cp	$fd
	jr	nz,.a4
	ld	hl,$001a	; ld a,(de) / nop
	ld	de,$b61a	; ld a,(de) / or (hl)
	ld	b,$00		; nop
	jr	.start

.a4:
	cp	$fe
	jr	nz,.a5
	ld	hl,$b61a	; ld a,(de) / or (hl)
	ld	de,$b61a	; ld a,(de) / or (hl)
	ld	b,$00		; nop
	jr	.start

.a5:
	cp	$ff
	jr	nz,.a6
	ld	hl,$ae1a	; ld a,(de) / xor (hl)
	ld	de,$ae1a	; ld a,(de) / xor (hl)
	jr	.start

.a6:
	ld	hl,$007e	; ld a,(hl) / nop
	ld	de,$007e	; ld a,(hl) / nop

.start:
	ld	(DRAWMxN_R.p00),hl
	ld	(DRAWMxN_R.p01),hl
	ld	(DRAWMxN_R.p02),hl
	ld	(DRAWMxN_R.p03),hl
	ld	(DRAWMxN_L.p00),hl
	ld	(DRAWMxN_L.p01),hl
	ld	(DRAWMxN_L.p02),hl
	ld	(DRAWMxN_L.p03),hl

	ex	de,hl
	ld	(DRAWMxN_R.p10),hl
	ld	(DRAWMxN_R.p11),hl
	ld	(DRAWMxN_R.p12),hl
	ld	(DRAWMxN_R.p13),hl
	ld	(DRAWMxN_L.p10),hl
	ld	(DRAWMxN_L.p11),hl
	ld	(DRAWMxN_L.p12),hl
	ld	(DRAWMxN_L.p13),hl

	ld	a,b
	ld	(DRAWMxN_R.i0),a
	ld	(DRAWMxN_R.i1),a
	ld	(DRAWMxN_R.i2),a
	ld	(DRAWMxN_R.i3),a
	ld	(DRAWMxN_L.i0),a
	ld	(DRAWMxN_L.i1),a
	ld	(DRAWMxN_L.i2),a
	ld	(DRAWMxN_L.i3),a

	pop	bc
	pop	de
	pop	hl

	call	VADDCONV
	ex	de,hl
	jp	c,DRAWMxN_R

;
; MxN`ij
; HLFp^[AhX
; DEFVRAMAhX
;
DRAWMxN_L:
.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

.p00:	ld	a,(hl)
	nop
	ld	(de),a
.i0:	inc	hl
	inc	e
.p10:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl
	inc	e
.p01:	ld	a,(hl)
	nop
	ld	(de),a
.i1:	inc	hl
	inc	e
.p11:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

.p02:	ld	a,(hl)
	nop
	ld	(de),a
.i2:	inc	hl
	inc	e
.p12:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl
	inc	e
.p03:	ld	a,(hl)
	nop
	ld	(de),a
.i3:	inc	hl
	inc	e
.p13:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	djnz	.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e
	jp	z,DRAWMxN_R_CNT

	dec	c
	jr	nz,.lp2

	ret

;
; MxN`iEj
; HLFp^[AhX
; DEFVRAMAhX
;
DRAWMxN_R:
.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

.p00:	ld	a,(hl)
	nop
	ld	(de),a
.i0:	inc	hl
	inc	e
.p10:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl
	inc	e
.p01:	ld	a,(hl)
	nop
	ld	(de),a
.i1:	inc	hl
	inc	e
.p11:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

.p02:	ld	a,(hl)
	nop
	ld	(de),a
.i2:	inc	hl
	inc	e
.p12:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl
	inc	e
.p03:	ld	a,(hl)
	nop
	ld	(de),a
.i3:	inc	hl
	inc	e
.p13:	ld	a,(hl)
	nop
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	dec	d

	ld	a,e
	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	ld	e,a
	djnz	.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e

.cont:
	dec	c
	jr	nz,.lp2

	ret


DRAWMxN_R_CNT:
	call	CALCVRAM_L2R

	jr	DRAWMxN_R.cont


;
; VRAMAhXEZo
; DFVRAMAhX
; DEFVRAMEAhX
;
CALCVRAM_L2R:
	ld	a,d
	sub	$1a
	srl	a
	ld	d,a

	rrca
	rrca				; Y5-0 => Y1-0,,Y5-2
	and	$c0			; Y1-0 => b7,6
	ld	e,a

	ld	a,d
	rrca				; Y0,,Y5-1
	and	$1e			; Y5-2 => b4-1
	ld	d,a

	ret

;
; 88pVRAMAhXP6pVRAMAhXɕϊ
; Y2hbgP
;
; HLF88pVRAMAhX
; RETURN
; HLFP6pVRAMAhX
; Cflag=1FE
;
VADDCONV:
	ld	a,h
	sub	$c0
	ld	h,a
	ld	a,160
	call	HL_DIV_A	; HLFYW(/2)AAFXWi/8j
	ld	h,l		; HFYWi/2j
	ld	l,a		; LFXWi/8j

	sla	l
	sla	l
	jr	c,.ov256	; LF64`79̎AWv

	ld	a,h
	add	a,$1a+$00	; Cflag=0
	ld	h,a

	or	a
	ret

.ov256:
	ld	a,h
	and	$06		; Y2,1
	rrca
	rrca
	rrca			; Y2,1 => b7,6
	add	a,l
	ld	l,a

	ld	a,h
	and	$f8		; Y7-3
	rrca
	rrca			; Y7-3 => b12-9
	bit	0,h
	jr	z,.nob82
	inc	a		; Y0 => b8
.nob82:
	add	a,$00		; Cflag=0
	ld	h,a

	scf
	ret

;
; HL / A => HL ... A
;
HL_DIV_A:
	push	de
	push	bc

	ld	c,a
	xor	a
	ld	de,0

	ld	b,16
.lp1:
	sla	l
	rl	h
	rla
	jr	nc,.next1
	sub	c
	or	a
	jr	.next2

.next1:
	sub	c
	jr	nc,.next2
	add	a,c
	scf
.next2:
	ccf
	rl	e
	rl	d

	djnz	.lp1

	ex	de,hl

	pop	bc
	pop	de
	ret

	

;
; eLXgVRAMpobt@NA
;
CLRTXT:
	push	hl
	push	bc
	push	af

	ld	hl,CHRBUF
	ld	a,' '
	ld	bc,120*25
.lp1:
	ld	(hl),a
	cpi
	jp	pe,.lp1

	pop	af
	pop	bc
	pop	hl
	ret

;
; eLXgVRAMNA
;
CLRTXTVRAM:
	push	hl
	push	de
	push	bc
	push	af

	ld	a,$08		; 0x8000-0xBFFF̓ǂݏRAMɂ
	call	ACCBANK45

	ld	hl,$8000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$8000
	ex	de,hl
	ld	bc,80*25*2-1
	ldir

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; ʂeLXgɂ
;
TXTON:
	push	af
	ld	a,$02
	out	($93),a
	ld	a,$f5		; 80 LN^\
	out	($c1),a
	ld	a,$08
	out	($c9),a		; VRAM擪AhX̐ݒ
	ld	a,$03
	out	($93),a
	pop	af
	ret

;
; ʂOtBbNɂ
;
GRON:
	push	af
	push	bc
	ld	a,$02
	out	($93),a
	ld	a,$f1		; 640x200OtBbN\
	out	($c1),a

	ld	bc,$07c9
	xor	a
.lp1:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.lp1

	ld	a,$03
	out	($93),a
	pop	bc
	pop	af
	ret

;
; @epobt@̃NA
;
MAGICBUFCLR:
	push	hl
	push	de
	push	bc
	push	af

	ld	a,$0c		; 0x8000-0xBFFF̓ǂݏRAM0xc000`ɂ
	call	ACCBANK45

	ld	hl,MAGICBUFLIST
	ld	a,$00
	ld	b,$00
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; obt@ɑ݂邩ǂmF
; DEFL[
; RETURN
; HLFobt@AhX
; DEFobt@XgAhX
; Cflag=1A݂Ȃ
;
BUFFIND:
	ld	hl,MAGICBUFLIST
	ld	b,$80
.lp1:
	ld	a,(hl)
	inc	hl
	xor	e
	ld	c,a

	ld	a,(hl)
	xor	d
	or	c
	jr	z,.eq
	inc	hl

	djnz	.lp1
	scf
	ret

.eq:
	dec	hl
	push	hl

	ld	de,MAGICBUFLIST
	or	a
	sbc	hl,de		; 0x02
	add	hl,hl		; 0x04
	add	hl,hl		; 0x08
	add	hl,hl		; 0x10
	add	hl,hl		; 0x20
	ld	de,MAGICBUF
	add	hl,de

	pop	de
	or	a
	ret

;
; obt@̈mۂ
; DEFL[
; RETURN
; HLFobt@AhX
; Cflag=1A󂫂Ȃ
;
BUFGET:
	ld	hl,MAGICBUFLIST
	ld	b,$80
.lp1:
	ld	a,(hl)
	inc	hl
	or	(hl)
	jr	z,.next
	inc	hl
	djnz	.lp1

	scf
	ret

.next:
	ld	(hl),d
	dec	hl
	ld	(hl),e		; HLFobt@XgAhX
				; DEFL[

	push	de

	ld	de,MAGICBUFLIST
	or	a
	sbc	hl,de		; 0x02
	add	hl,hl		; 0x04
	add	hl,hl		; 0x08
	add	hl,hl		; 0x10
	add	hl,hl		; 0x20
	ld	de,MAGICBUF
	add	hl,de

	pop	de
	or	a
	ret

;
; 32x16̉ʂۑi16x8Pʁji@epj
; HLF88pVRAMAhX
; A Fʁi0x00/0x01j
;
BUFMAGIC_32x16:
	push	af
	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ
	ld	a,$0c		; 0x8000-0xBFFF̓ǂݏRAM0xc000`ɂ
	call	ACCBANK45
	pop	af

	push	hl
	push	de
	call	BUFMAGIC_16x8
	inc	hl
	inc	hl
	call	BUFMAGIC_16x8
	ld	de,640-2
	add	hl,de
	call	BUFMAGIC_16x8
	inc	hl
	inc	hl
	call	BUFMAGIC_16x8
	pop	de
	pop	hl

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45
	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	ret

;
; ۑ32x16̉ʂ\i16x8Pʁji@epj
; HLF88pVRAMAhX
;
DRAWBUFMAGIC_32x16:
	push	af
	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ
	ld	a,$0c		; 0x8000-0xBFFF̓ǂݏRAM0xc000`ɂ
	call	ACCBANK45
	pop	af

	push	hl
	push	de
	call	DRAWBUFMAGIC_16x8
	inc	hl
	inc	hl
	call	DRAWBUFMAGIC_16x8
	ld	de,640-2
	add	hl,de
	call	DRAWBUFMAGIC_16x8
	inc	hl
	inc	hl
	call	DRAWBUFMAGIC_16x8
	pop	de
	pop	hl

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45
	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	ret

;
; 16x8̉ʂۑi@epj
; HLF88pVRAMAhX
; A Fʁi0x00/0x01j
;
BUFMAGIC_16x8:
	push	hl
	push	de
	push	bc
	push	af

	ld	e,l
	ld	d,h		; DEFL[

	or	a
	jr	nz,.after

	push	hl
	push	de
	call	BUFFIND
	pop	de
	pop	hl
	jr	nc,.end		; t@CɂꍇAWv

.cnt1:
	push	hl
	call	BUFGET
	ex	de,hl		; DEFobt@AhX
	pop	hl		; HLF88pVRAMAhX
	jr	c,.end		; 󂫂ȂꍇAWv

.cnt2:
	call	VADDCONV
	ex	de,hl		; DEFVRAMAhX
				; HLFobt@AhX

	call	nc,BUF16x8_L
	call	c, BUF16x8_R

.end:
	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

.after:
	inc	de		; DEFL[

	push	hl
	push	de
	call	BUFFIND
	jr	nc,.find	; t@Cꍇ͏㏑
	pop	de
	pop	hl
	jr	.cnt1		; t@CȂꍇ́Aʏ펞Ɠ

.find:
	pop	de
	pop	de
	ex	de,hl
	jr	.cnt2


;
; ۑ16x8̉ʂ`悷i@epj
; HLF88pVRAMAhX
;
DRAWBUFMAGIC_16x8:
	push	hl
	push	de
	push	bc
	push	af

	push	hl
	call	VADDCONV
	ex	de,hl		; DEFVRAMAhX
	ld	hl,CHRBUF	; HLFobt@AhX
	call	nc,BUF16x8_L
	call	c, BUF16x8_R
	pop	hl

	push	hl
	ld	e,l
	ld	d,h
	inc	e		; DEFL[iA=0x01j
	call	BUFFIND
	jr	c,.popend	; t@CȂꍇAWv

	xor	a
	ld	(de),a		; obt@XgNA
	inc	de
	ld	(de),a		; obt@XgNA

	ld	de,CHRBUF
	ld	b,2*8*2
	ld	c,0
.lp1:
	ld	a,(de)
	xor	(hl)
	add	a,c
	ld	c,a
	jr	nz,.noteq	; sv̏ꍇAWv
	inc	hl
	inc	de
	djnz	.lp1
.noteq:
	pop	hl

	push	hl
	push	bc
	ex	de,hl		; DEFL[iA=0x00j
	call	BUFFIND
	pop	bc
	jr	c,.popend	; t@CȂꍇAWv

	xor	a
	ld	(de),a		; obt@XgNA
	inc	de
	ld	(de),a		; obt@XgNA

	ex	de,hl		; DEFobt@AhX
	pop	hl		; HLF88pVRAMAhX

	ld	a,c
	or	a
	jr	nz,.end

	call	VADDCONV
	ex	de,hl		; DEFVRAMAhX
				; HLFobt@AhX
	call	nc,DRAWBUF16x8_L
	call	c, DRAWBUF16x8_R

.end:
	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

.popend:
	pop	hl
	jr	.end

;
; 16x8̉ʂۑTuipj
; HLFobt@AhX
; DEFVRAMAhX
;
BUF16x8_L:
	push	af

.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	djnz	.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e

	dec	c
	jr	nz,.lp2

.end:
	pop	af
	ret

;
; 16x8̉ʂۑTuiEpj
; HLFobt@AhX
; DEFVRAMAhX
;
BUF16x8_R:
	push	af

.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	e
	ld	a,(de)
	ld	(hl),a
	inc	hl

	dec	e
	dec	e
	dec	e
	dec	d

	ld	a,e
	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	ld	e,a
	djnz	.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e

	dec	c
	jr	nz,.lp2

	pop	af
	ret

;
; ۑ16x8̉ʂ`悷Tuipj
; HLFobt@AhX
; DEFVRAMAhX
;
DRAWBUF16x8_L:
	push	af

.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	djnz	.lp1
	pop	de

	inc	e
	inc	e
	inc	e
	inc	e

	dec	c
	jr	nz,.lp2

.end:
	pop	af
	ret

;
; ۑ16x8̉ʂ`悷TuiEpj
; HLFobt@AhX
; DEFVRAMAhX
;
DRAWBUF16x8_R:
	push	af

.xsz:	ld	c,2
.lp2:
	push	de
.ysz:	ld	b,2
.lp1:

	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	inc	d

	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	ld	a,(hl)
	ld	(de),a
	inc	hl

	dec	e
	dec	e
	dec	e
	dec	d

	ld	a,e
	add	a,$40
	jr	nc,.n1
	inc	d
	inc	d
.n1:
	ld	e,a
	djnz	.lp1

	pop	de
	inc	e
	inc	e
	inc	e
	inc	e

	dec	c
	jr	nz,.lp2

	pop	af
	ret

;
; ʉۑ
;
BUFWINDBOX:
	push	hl
	push	de
	push	bc
	push	af

	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ
	ld	a,$08		; 0x8000-0xBFFF̓ǂݏRAMɂ
	call	ACCBANK45

	ld	hl,$6a00	; (160,0)
	ld	de,WINDBUF
	ld	b,40/2
.lp1:
	push	bc
	ld	bc,60*2*2
	ldir

	pop	bc
	inc	h
	ld	l,$00
	djnz	.lp1

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45
	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; EChɋ``
;
DRAWWINDBOX:
	push	hl
	push	de
	push	bc
	push	af

	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ

	ld	hl,$6a00	; (160,0)
	ld	b,40/2
.lp3:
	push	bc

	xor	a
	ld	c,$ff
	ld	b,60*2
.lp2:
	ld	(hl),a
	inc	l
	ld	(hl),c
	inc	l
	djnz	.lp2

	pop	bc
	inc	h
	ld	l,$00
	djnz	.lp3

	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; ۑʉ߂
;
DRAWWINDBUF:
	push	hl
	push	de
	push	bc
	push	af

	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ
	ld	a,$08		; 0x8000-0xBFFF̓ǂݏRAMɂ
	call	ACCBANK45

	ld	de,$6a00	; (160,0)
	ld	hl,WINDBUF
	ld	b,40/2
.lp1:
	push	bc
	ld	bc,60*2*2
	ldir

	pop	bc
	inc	d
	ld	e,$00
	djnz	.lp1

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45
	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; EChɃeLXg\
;
DISPWIND:
	push	hl
	push	de
	push	bc
	push	af

	call	RWVRAM		; 0x0000-0x7FFF̓ǂݏRAMɂ
	ld	a,$d0		; 0x8000-0xBFFF̓ǂݏCGROMɂ
	call	ACCBANK45

	ld	de,CHRBUF+120*20
	ld	hl,$6a00	; (160,0)

.lp2:
	push	de		; DEF|C^
	push	hl		; HLFVRAMAhX

		;
		; tHgf[^ǂݏo
		;
	push	hl
	ld	a,(de)
	ld	l,a
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	ld	bc,$9000
	add	hl,bc
	ex	de,hl		; DEFtHgf[^AhX
	pop	hl

	ld	c,$ff
	ld	b,8/2
.lp1:
	ld	a,(de)
	inc	de
	ld	(hl),a
	inc	l
	ld	(hl),c
	inc	l
	ld	a,(de)
	inc	de
	ld	(hl),a
	inc	l
	ld	(hl),c
	dec	l
	dec	l
	dec	l
	inc	h
	djnz	.lp1

	pop	hl		; HLFVRAMAhX
	pop	de		; DEF|C^

	inc	l
	inc	l
	inc	l
	inc	l
	inc	de

	ld	a,l
	cp	60*2*2
	jr	nz,.lp2

	push	hl
	ld	hl,60
	add	hl,de
	ex	de,hl
	pop	hl

	ld	l,0
	inc	h
	inc	h
	inc	h
	inc	h

	ld	a,h
	cp	$7e
	jr	nz,.lp2

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45
	call	RWMRAM		; 0x0000-0x7FFF̓ǂݏORAMɖ߂

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; eLXgVRAMpobt@̃f[^eLXgVRAMɓ]
;
DISPTXT:
	push	hl
	push	de
	push	bc
	push	af

	ld	a,$08		; 0x8000-0xBFFF̓ǂݏRAMɂ
	call	ACCBANK45

	ld	de,$8000
	ld	hl,CHRBUF

	ld	b,25
.lp2:
	push	bc
	ld	b,80
.lp1:
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de
	inc	de
	djnz	.lp1

	ld	bc,40
	add	hl,bc

	pop	bc
	djnz	.lp2

	ld	a,$28		; 0x8000-0xBFFF̓ǂݏORAMɖ߂
	call	ACCBANK45

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; eLXgVRAM]{eL[
;
DISP_TENKEY:
	call	DISPTXT
	call	$9794
	ret

;
; eLXgVRAM]{ԑ҂
;
DISP_WAIT:
	call	DISPTXT
	call	$68d4
	ret

;
; RETURNL[͑҂
;
WAITRET:
.lp:
	rst	$08
	cp	$0d		; RETURN
	jr	nz,.lp
	ld	a,$00
	ld	(KEYDATA),a
	ret

;
; SHOCK̐Ղ
;
ERASESHOCK:
	ld	bc,($71e0)
	call	$6712
	ld	bc,($71ef)
	call	$6712
	ld	bc,($71fe)
	call	$6712
	ld	bc,($720d)
	call	$6712
	ld	bc,($721c)
	call	$6712
	ret

;
; BEAM`
;
BEAMDRAW:
	ld	d,2
.lp1:
	push	de

	ld	bc,($bead)
	ld	a,b
	add	a,d
	cp	29
	jr	nc,.next1

	ld	b,a
	call	$338b
	ld	de,$5821	; BEAM
	call	DRAW_PG		; 32x16L`
.next1:
	pop	de

	push	de
	ld	bc,($bead)
	ld	a,b
	sub	d
	jr	c,.next2

	ld	b,a
	call	$338b
	ld	de,$5821	; BEAM
	call	DRAW_PG		; 32x16L`

.next2:
	pop	de
	inc	d
	ld	a,d
	cp	30
	jr	nz,.lp1

	ret

;
; BEAM̐Ղ
;
ERASEBEAM:
	ld	d,2
.lp1:
	push	de
	ld	bc,($bead)
	ld	a,b
	add	a,d
	cp	29
	jr	nc,.next1
	ld	b,a
	call	$6712
.next1:
	pop	de

	push	de
	ld	bc,($bead)
	ld	a,b
	sub	d
	jr	c,.next2
	ld	b,a
	call	$6712
.next2:
	pop	de

	inc	d
	ld	a,d
	cp	30
	jr	nz,.lp1

	ret

;
; vȌI
;
	org	$c8ff
	db	$ff


end

