;
; Np
;

	relaxed on

START2		equ	$e000
START3		equ	$c100

Disk_Routine	equ	$e300

Disk_Init	equ	Disk60_Entry+0
Disk_Load	equ	Disk60_Entry+3
Disk_Change1DD	equ	Disk60_Entry+12

KEYDATA		equ	$e224	; L[̓obt@
GAMEDATA	equ	$e225	; Q[L[̓obt@

PROG1_ST	equ	$0000
PROG2_ST	equ	$0038


	org	$c000

;
; Track#0 Sector#1`
;
	db	"IPL"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	jr	c,DISKERR
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

;
; ʃNAiLN^j
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

;
; \
;
PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	inc	hl
	jr	.msglp

DISKERR_MSG:
	db	"Disk error",$00

RAMERR_MSG:
	db	"64K"
	db	''+$20
	db	' '
	db	"RAM"
	db	''-$20
	db	''
	db	' '
	db	''+$20
	db	''+$20
	db	''+$20
	db	''-$20
	db	''+$20
	db	''
	db	''-$20
	db	''
	db	$00

;
; fBXNG[
;
DISKERR:
	ld	de,DISKERR_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

;
; RAMG[
;
RAMERR:
	ld	a,$0e
	out	($6f),a		; 0xE000`0xFFFFRAM߂
	ld	de,RAMERR_MSG
	ld	hl,$f000
	call	PNT_MSG

;
; RAMG[AbZ[W𗬂
; gbN#0ZN^#4
;
	xor	a		; hCuԍ-1
	ld	($ed66),a
	ld	bc,$0004	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,START3	; i[AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	jp	START3


;
; CX^[g
;
START:

	ld	sp,$c300

	call	CURCLS		; ʃNA

;
; OtRAM̃`FbN
;
	di

	ld	a,$20		; 0x0000-0x1FFF̓ǂݏORAM
	out	($60),a
	out	($68),a
	add	a,4		; 0x4000-0x5FFF̓ǂݏORAM
	out	($62),a
	out	($6a),a
	add	a,4		; 0x8000-0x9FFF̓ǂݏORAM
	out	($64),a
	out	($6c),a

	ld	bc,$5aa5
	ld	d,$96
	ld	hl,$00ff
	ld	(hl),b
	ld	h,$40
	ld	(hl),c
	ld	h,$80
	ld	(hl),d

	ld	h,$00
	ld	a,(hl)
	cp	b
	jr	nz,.rcend
	ld	h,$40
	ld	a,(hl)
	cp	c
	jr	nz,.rcend
	ld	h,$80
	ld	a,(hl)
	cp	d

.rcend:
	ld	a,$f8		; 0x0000-0x1FFF̓ǂݏoBASIC-ROMɖ߂
	out	($60),a
	ld	a,$fc		; 0x4000-0x5FFF̓ǂݏoBASIC-ROMɖ߂
	out	($62),a

	jr	nz,RAMERR

	ei

;
; u[gvȎǂݍ
; gbN#0ZN^#1-3
;
	xor	a		; hCuԍ-1
	ld	($ed66),a
	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,START2	; i[AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC


;
; fBXNǂݏ[`ǂݍ
; gbN#0ZN^#5-7 ij
; gbN#0ZN^#8-10iOj
;
	ld	c,$05		; CregFZN^ԍihCupǂݏo[`j

	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	c,$08		; CregFZN^ԍiOthCupǂݏo[`j
.fd_in:

	ld	b,$00		; BregFgbNԍ
	ld	de,Disk_Routine	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC


	di

;
; ORAMփvO]
;
	ld	a,$2c		; 0xc000-0xdfff݂̏ORAM
	out	($6e),a
	add	a,2		; 0xe000-0xffff݂̏ORAM
	out	($6f),a	

	ld	hl,$c000
	ld	de,$c000
	ld	bc,$4000
	ldir

	ld	a,$2e
	out	($67),a		; 0xe000-0xffff̓ǂݏoORAM

	jp	START2


;
; u[g̑
;
	org	$c100
;
; Track#0 Sector#4
;
	phase	START2

	ld	a,$20		; 0x0000-0x1fff̓ǂݏORAM
	out	($60),a	
	out	($68),a	
	add	a,2		; 0x2000-0x3fff̓ǂݏORAM
	out	($61),a	
	out	($69),a	
	add	a,2		; 0x4000-0x5fff̓ǂݏORAM
	out	($62),a	
	out	($6a),a	
	add	a,2		; 0x6000-0x7fff̓ǂݏORAM
	out	($63),a	
	out	($6b),a	
	add	a,2		; 0x8000-0x9fff̓ǂݏORAM
	out	($64),a	
	out	($6c),a	
	add	a,2		; 0xa000-0xbfff̓ǂݏORAM
	out	($65),a	
	out	($6d),a	
	add	a,2		; 0xc000-0xdfff̓ǂݏORAM
	out	($66),a	
	out	($6e),a	
	add	a,2		; 0xe000-0xffff݂̏ORAM
	out	($6f),a	

	ld	sp,$e000

;
; fBXN[`̏
;
	ld	d,$00
	call	Disk_Init
	jp	c,DISKERR

	ld	d,$00
	call	Disk_Change1DD
	jp	c,DISKERR



;
; 荞ݏ[h
;
	ld	de,$0101	; DregFgbNԍAEregFZN^ԍ
	ld	bc,$0100	; BregFZN^ACregFhCuԍ
	ld	hl,$e200	; i[擪AhX
	call	Disk_Load


;
; VXȅ
;
SYSINIT:
	im	2
	ld	a,$e2
	ld	i,a		; 荞݃e[u0xe200`ɐݒ

	ld	a,$fa		; 荞݂^C}ASUB-CPÛ݂ɂ
	out	($fa),a

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$f1		; 420x200 OtBbN
	out	($c1),a

	ld	c,$00
	call	VRAMCLR

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

	ld	a,$00
	out	($40),a		; pbgݒi"11"=j
	ld	a,$06
	out	($41),a		; pbgݒi"10"=j
;	ld	a,$0a
;	out	($41),a		; pbgݒi"10"=Fj
	ld	a,$05
	out	($42),a		; pbgݒi"01"=ԁj
	ld	a,$07
	out	($43),a		; pbgݒi"00"=j

	ld	a,$03
	out	($93),a		; ʂ\

	ld	de,$07bf	; ~LT[FSďo͂Ȃ
	call	OUTOPN

	ld	b,3
	ld	de,$0800	; `l``b̉
.lp1:	call	OUTOPN
	inc	d
	djnz	.lp1

	ld	b,3
	ld	de,$2800	; S`lL[It
.lp2:	call	OUTOPN
	inc	e
	djnz	.lp2


;
; ǉvO]
;
	ld	hl,PROG1
	ld	de,PROG1_ST
	ld	bc,PROG1.ed-PROG1.st
	ldir

	ld	hl,PROG2
	ld	de,PROG2_ST
	ld	bc,PROG2.ed-PROG2.st
	ldir

	ei

;
; fBXN[h
;
	ld	de,$0201	; DregFgbNԍAEregFZN^ԍ
	ld	bc,$0400	; BregFZN^ACregFhCuԍ
	ld	hl,$d000	; i[擪AhX
	call	Disk_Load

;
; CvO[h
;
	ld	de,$3e01	; DregFgbNԍAEregFZN^ԍ
	ld	bc,$c800	; BregFZN^ACregFhCuԍ
	ld	hl,$0100	; i[擪AhX
	call	Disk_Load

	jp	$0100


;
; VRAMNA
; CFNAf[^
;
VRAMCLR:
	ld	a,$ea		; ڃANZX[hɐݒ^y[WO\
	out	($c8),a

	xor	a
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a

	ld	hl,$0000
.lp1:	ld	(hl),c
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

	ld	a,$20
	out	($68),a
	add	a,2
	out	($69),a
	add	a,2
	out	($6a),a
	add	a,2
	out	($6b),a

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	ret


;
; OPNɏo͂
; DFAhX
; EFf[^
;
OUTOPN:
	ld	a,d
	out	($a0),a

.lp1:	in	a,($a3)
	rlca
	jr	c,.lp1

	ld	a,e
	out	($a1),a

.lp2:	in	a,($a3)
	rlca
	jr	c,.lp2

	ret


PROG1:
.st:
	di			; 0x0000
	jr	$
	nop
	nop
	jp	$d000		; 0x0005

	ld	a,(KEYDATA)	; 0x0008
	ret
	nop
	nop
	nop
	nop

	ld	a,(GAMEDATA)	; 0x0010
	ret
.ed:


PROG2:
.st:
	di			; 0x0038
	jr	$
.ed:


	dephase


	org	$c300
;
; Track#0 Sector#4
;
	phase	START3

PROTECT:

	xor	a		; 0x0000-0x1FFF݂̏RAM
	out	($68),a	
	add	a,4		; 0x4000-0x5FFF݂̏RAM
	out	($6a),a	
	add	a,4		; 0x8000-0x9fff̓ǂݏRAM
	out	($64),a	
	out	($6c),a	

	ei

	ld	b,$05		; Breg:gbNԍ
	ld	de,$0000	; i[AhX

.lp1:
	ld	c,$01		; Creg:ZN^ԍ
	ld	a,$10		; ǂݍރZN^
	call	READ_NSEC

	inc	b
	ld	a,d
	cp	$c0
	jr	nz,.lp1

	di

	xor	a		; 0x0000-0x1FFF̓ǂݏoRAM
	out	($60),a	
	add	a,2		; 0x2000-0x3FFF̓ǂݏoRAM
	out	($61),a	
	add	a,2		; 0x4000-0x5FFF̓ǂݏoRAM
	out	($62),a	
	add	a,2		; 0x6000-0x7FFF̓ǂݏoRAM
	out	($63),a	

	ld	a,$07
	out	($a0),a
	ld	a,$bf		; g[A/B/C fBZ[u
	out	($a1),a

.lp4:
	ld	hl,$0000
.lp3:
	ld	b,8
.lp2:
	ld	a,$08
	out	($a0),a
	rrc	(hl)
	jp	c,.son
.soff:
	ld	a,$00
	out	($a1),a
	jp	.send
.son:
	ld	a,$0f
	out	($a1),a
.send:

	djnz	.lp2
	inc	hl

	ld	a,h
	cp	$c0
	jr	nz,.lp3

	jr	.lp4


	dephase



	org	$c400
;
; Track#0 Sector#5-7
;
	phase	Disk_Routine

	include	"disk66.z80"	; hCupǂݏo[`

	dephase



	org	$c700
;
; Track#0 Sector#8-10
;
	phase	Disk_Routine

	include	"disk.z80"	; OthCupǂݏo[`

	dephase


	org	$c9ff
	db	$ff


end

