/****************************/
/* convert message          */
/*                          */
/* ͂Ђ炪Ȃɕϊ */
/****************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXWORD		255
#define	MAXWORDLEN	16
#define	MAXLINE		255
#define	MAXDATA		0x10000

void hiraconv(unsigned char word[MAXWORD],unsigned char newword[MAXWORD]);
void fprintp6dat(unsigned char word[MAXWORD],FILE *outfp);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp, *mesfp;

	int		c;
	int		i,j,k;
	char	line[MAXLINE];
	unsigned char	indata[MAXDATA];
	int		stadd,st;
	int		wadd;
	int		dtlen;

	unsigned char	word[MAXWORD];
	unsigned char	newword[MAXWORD];

	if (argc != 4) {
		fprintf(stderr, "Usage: convmsg inputfile outputfile messagelist\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((mesfp = fopen(argv[3], "r")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	dtlen = 0;
	while ( (c = fgetc(infp)) != EOF) {
		indata[dtlen] = c;
		dtlen ++;
	}


	if ( fgets(line, MAXLINE, mesfp) != NULL) {
		sscanf(line,"%x",&stadd);
	}

	while ( fgets(line, MAXLINE, mesfp) != NULL) {
		sscanf(line,"%x",&st);

		j = 0;
		wadd = st-stadd;
		for (i = st-stadd;indata[i] != 0;i ++) {
			word[j] = indata[i];
			j ++;
			if (j >= 80) {
				word[j] = 0;
				hiraconv(word,newword);

				for (k = 0;k < j;k ++) {
					indata[wadd+k] = newword[k];
				}

				j = 0;
				wadd = wadd+80;

//				fprintp6dat(newword,outfp);
//				fprintf(outfp,"\n");
			}
		}

		if (j != 0) {
			word[j] = 0;
			hiraconv(word,newword);

			for (k = 0;k < j;k ++) {
				indata[wadd+k] = newword[k];
			}

//			fprintp6dat(newword,outfp);
//			fprintf(outfp,"\n");
		}

//		fprintf(outfp,"\n");

	}


	for (i = 0;i < dtlen;i ++) {
		fputc(indata[i],outfp);
	}


	fclose(infp);
	fclose(outfp);
	fclose(mesfp);

	return(0);

}

void hiraconv(unsigned char word[MAXWORD],unsigned char newword[MAXWORD])
{
	int		i,j,k,m;
	int		equflag;

	unsigned char kataword[][MAXWORDLEN] = {
		"",
		"",
		"",
		"ڸ",
		"ڲ",
		"ڲ԰",
		"׺",
		"׺ݽ",
		"",
		"׸",
		"",
		"",
		"-",
		"ް",
		"ް",
		"",
		"ٰگ",
		"ް",
		"",
		"װ",
		"׺Ư",
		"ذޮƽ",
		"׷",
		"ް",
		"Ų",
		0x00
	};

	unsigned char hiraword[][2][MAXWORDLEN] = {
		"3¸",	{'3'     ,''     ,''-0x20,''+0x20,''     },
		"Ͻ",	{''-0x20,''-0x20,''+0x20,''-0x20,''     },
		"ȴ",	{''+0x20,''+0x20,''+0x20,''-0x20,''     },
		"ۮ",	{''-0x20,''-0x20,''+0x20,''+0x20,''+0x20,''     },
		"Ů",	{''+0x20,''     ,''+0x20,''+0x20,''     },
		"Ȫ",	{''-0x20,''+0x20,''+0x20,''-0x20,''     },
		0x00
	};

	unsigned char keisen[][2] = {
		{0x90,	0x11},
		{0x91,	0x12},
		{0x92,	0x13},
		{0x93,	0x14},
		{0x8f,	0x15},
		{0x96,	0x16},
		{0x95,	0x17},
		{0x98,	0x18},
		{0x99,	0x19},
		{0x9a,	0x1a},
		{0x9b,	0x1b},
		{0xe0,	0x17},
		{0xe1,	0x14},
		{0xe2,	0x15},
		{0xe3,	0x13},
		{0x00,	0x00}
	};

	strcpy(newword,word);


	for (i = 0;;i ++) {
		if (keisen[i][0] == 0) {
			break;
		}
		for (j = 0;word[j] != 0;j ++) {
			if (keisen[i][0] == word[j]) {
				newword[j] = keisen[i][1];
			}
		}
	}


// J^JiЂ炪
	for (i = 0;word[i] != 0;i ++) {
		if        (0xa6 <= word[i] && word[i] <= 0xaf) {
			newword[i] -= 0x20;
		} else if (0xb1 <= word[i] && word[i] <= 0xbf) {
			newword[i] -= 0x20;
		} else if (0xc0 <= word[i] && word[i] <= 0xdd) {
			newword[i] += 0x20;
		} else {
			;
		}
	}


// Ђ炪ȁJ^Ji
	for (i = 0;;i ++) {

		if (kataword[i][0] == 0) {
			break;
		}

		for (j = 0;word[j] != 0;j ++) {

			equflag = 1;
			for (k = 0;kataword[i][k] != 0;k ++) {
				if (word[j+k] == 0) {
					equflag = 0;
					break;
				}

				if (word[j+k] != kataword[i][k]) {
					equflag = 0;
					break;
				}
			}

			if (equflag != 0) {
				for (m = j;m < j+k;m ++) {
					newword[m] = word[m];
				}
			}

		}
	}

// Ђ炪ȁJ^JiЂ炪
	for (i = 0;;i ++) {

		if (hiraword[i][0][0] == 0) {
			break;
		}

		for (j = 0;word[j] != 0;j ++) {

			equflag = 1;
			for (k = 0;hiraword[i][0][k] != 0;k ++) {
				if (word[j+k] == 0) {
					equflag = 0;
					break;
				}

				if (word[j+k] != hiraword[i][0][k]) {
					equflag = 0;
					break;
				}
			}

			if (equflag != 0) {
				for (m = j;m < j+k;m ++) {
					newword[m] = hiraword[i][1][m-j];
				}
			}

		}
	}

	return;

}

void fprintp6dat(unsigned char word[MAXWORD],FILE *outfp)
{
	int		i;

	for (i = 0;word[i] != 0;i ++) {
		switch (word[i]) {

			case 0x00:
				fprintf(outfp,"@"); break;
			case 0x01:
				fprintf(outfp,""); break;
			case 0x02:
				fprintf(outfp,""); break;
			case 0x03:
				fprintf(outfp,""); break;
			case 0x04:
				fprintf(outfp,""); break;
			case 0x05:
				fprintf(outfp,""); break;
			case 0x06:
				fprintf(outfp,"y"); break;
			case 0x07:
				fprintf(outfp,""); break;
			case 0x08:
				fprintf(outfp,"N"); break;
			case 0x09:
				fprintf(outfp,"~"); break;
			case 0x0a:
				fprintf(outfp,""); break;
			case 0x0b:
				fprintf(outfp,""); break;
			case 0x0c:
				fprintf(outfp,"b"); break;
			case 0x0d:
				fprintf(outfp,"S"); break;
			case 0x0e:
				fprintf(outfp,""); break;
			case 0x0f:
				fprintf(outfp,""); break;

			case 0x10:
				fprintf(outfp,""); break;
			case 0x11:
				fprintf(outfp,""); break;
			case 0x12:
				fprintf(outfp,""); break;
			case 0x13:
				fprintf(outfp,""); break;
			case 0x14:
				fprintf(outfp,""); break;
			case 0x15:
				fprintf(outfp,""); break;
			case 0x16:
				fprintf(outfp,""); break;
			case 0x17:
				fprintf(outfp,""); break;
			case 0x18:
				fprintf(outfp,""); break;
			case 0x19:
				fprintf(outfp,""); break;
			case 0x1a:
				fprintf(outfp,""); break;
			case 0x1b:
				fprintf(outfp,""); break;
			case 0x1c:
				fprintf(outfp,"~"); break;
			case 0x1d:
				fprintf(outfp,""); break;
			case 0x1e:
				fprintf(outfp,""); break;
			case 0x1f:
				fprintf(outfp,""); break;

			case 0x20:
				fprintf(outfp,"@"); break;
			case 0x21:
				fprintf(outfp,"I"); break;
			case 0x22:
				fprintf(outfp,"h"); break;
			case 0x23:
				fprintf(outfp,""); break;
			case 0x24:
				fprintf(outfp,""); break;
			case 0x25:
				fprintf(outfp,""); break;
			case 0x26:
				fprintf(outfp,""); break;
			case 0x27:
				fprintf(outfp,"f"); break;
			case 0x28:
				fprintf(outfp,"i"); break;
			case 0x29:
				fprintf(outfp,"j"); break;
			case 0x2a:
				fprintf(outfp,""); break;
			case 0x2b:
				fprintf(outfp,"{"); break;
			case 0x2c:
				fprintf(outfp,"C"); break;
			case 0x2d:
				fprintf(outfp,"|"); break;
			case 0x2e:
				fprintf(outfp,"D"); break;
			case 0x2f:
				fprintf(outfp,"^"); break;

			case 0x30:
				fprintf(outfp,"O"); break;
			case 0x31:
				fprintf(outfp,"P"); break;
			case 0x32:
				fprintf(outfp,"Q"); break;
			case 0x33:
				fprintf(outfp,"R"); break;
			case 0x34:
				fprintf(outfp,"S"); break;
			case 0x35:
				fprintf(outfp,"T"); break;
			case 0x36:
				fprintf(outfp,"U"); break;
			case 0x37:
				fprintf(outfp,"V"); break;
			case 0x38:
				fprintf(outfp,"W"); break;
			case 0x39:
				fprintf(outfp,"X"); break;
			case 0x3a:
				fprintf(outfp,"F"); break;
			case 0x3b:
				fprintf(outfp,"G"); break;
			case 0x3c:
				fprintf(outfp,""); break;
			case 0x3d:
				fprintf(outfp,""); break;
			case 0x3e:
				fprintf(outfp,""); break;
			case 0x3f:
				fprintf(outfp,"H"); break;

			case 0x40:
				fprintf(outfp,""); break;
			case 0x41:
				fprintf(outfp,"`"); break;
			case 0x42:
				fprintf(outfp,"a"); break;
			case 0x43:
				fprintf(outfp,"b"); break;
			case 0x44:
				fprintf(outfp,"c"); break;
			case 0x45:
				fprintf(outfp,"d"); break;
			case 0x46:
				fprintf(outfp,"e"); break;
			case 0x47:
				fprintf(outfp,"f"); break;
			case 0x48:
				fprintf(outfp,"g"); break;
			case 0x49:
				fprintf(outfp,"h"); break;
			case 0x4a:
				fprintf(outfp,"i"); break;
			case 0x4b:
				fprintf(outfp,"j"); break;
			case 0x4c:
				fprintf(outfp,"k"); break;
			case 0x4d:
				fprintf(outfp,"l"); break;
			case 0x4e:
				fprintf(outfp,"m"); break;
			case 0x4f:
				fprintf(outfp,"n"); break;

			case 0x50:
				fprintf(outfp,"o"); break;
			case 0x51:
				fprintf(outfp,"p"); break;
			case 0x52:
				fprintf(outfp,"q"); break;
			case 0x53:
				fprintf(outfp,"r"); break;
			case 0x54:
				fprintf(outfp,"s"); break;
			case 0x55:
				fprintf(outfp,"t"); break;
			case 0x56:
				fprintf(outfp,"u"); break;
			case 0x57:
				fprintf(outfp,"v"); break;
			case 0x58:
				fprintf(outfp,"w"); break;
			case 0x59:
				fprintf(outfp,"x"); break;
			case 0x5a:
				fprintf(outfp,"y"); break;
			case 0x5b:
				fprintf(outfp,"m"); break;
			case 0x5c:
				fprintf(outfp,""); break;
			case 0x5d:
				fprintf(outfp,"n"); break;
			case 0x5e:
				fprintf(outfp,"O"); break;
			case 0x5f:
				fprintf(outfp,"Q"); break;

			case 0x60:
				fprintf(outfp,"@"); break;
			case 0x61:
				fprintf(outfp,""); break;
			case 0x62:
				fprintf(outfp,""); break;
			case 0x63:
				fprintf(outfp,""); break;
			case 0x64:
				fprintf(outfp,""); break;
			case 0x65:
				fprintf(outfp,""); break;
			case 0x66:
				fprintf(outfp,""); break;
			case 0x67:
				fprintf(outfp,""); break;
			case 0x68:
				fprintf(outfp,""); break;
			case 0x69:
				fprintf(outfp,""); break;
			case 0x6a:
				fprintf(outfp,""); break;
			case 0x6b:
				fprintf(outfp,""); break;
			case 0x6c:
				fprintf(outfp,""); break;
			case 0x6d:
				fprintf(outfp,""); break;
			case 0x6e:
				fprintf(outfp,""); break;
			case 0x6f:
				fprintf(outfp,""); break;

			case 0x70:
				fprintf(outfp,""); break;
			case 0x71:
				fprintf(outfp,""); break;
			case 0x72:
				fprintf(outfp,""); break;
			case 0x73:
				fprintf(outfp,""); break;
			case 0x74:
				fprintf(outfp,""); break;
			case 0x75:
				fprintf(outfp,""); break;
			case 0x76:
				fprintf(outfp,""); break;
			case 0x77:
				fprintf(outfp,""); break;
			case 0x78:
				fprintf(outfp,""); break;
			case 0x79:
				fprintf(outfp,""); break;
			case 0x7a:
				fprintf(outfp,""); break;
			case 0x7b:
				fprintf(outfp,"o"); break;
			case 0x7c:
				fprintf(outfp,"b"); break;
			case 0x7d:
				fprintf(outfp,"p"); break;
			case 0x7e:
				fprintf(outfp,"`"); break;
			case 0x7f:
				fprintf(outfp,"@"); break;

			case 0x80:
				fprintf(outfp,""); break;
			case 0x81:
				fprintf(outfp,""); break;
			case 0x82:
				fprintf(outfp,""); break;
			case 0x83:
				fprintf(outfp,""); break;
			case 0x84:
				fprintf(outfp,""); break;
			case 0x85:
				fprintf(outfp,""); break;
			case 0x86:
				fprintf(outfp,""); break;
			case 0x87:
				fprintf(outfp,""); break;
			case 0x88:
				fprintf(outfp,""); break;
			case 0x89:
				fprintf(outfp,""); break;
			case 0x8a:
				fprintf(outfp,""); break;
			case 0x8b:
				fprintf(outfp,""); break;
			case 0x8c:
				fprintf(outfp,""); break;
			case 0x8d:
				fprintf(outfp,""); break;
			case 0x8e:
				fprintf(outfp,""); break;
			case 0x8f:
				fprintf(outfp,""); break;

			case 0x90:
				fprintf(outfp,"@"); break;
			case 0x91:
				fprintf(outfp,""); break;
			case 0x92:
				fprintf(outfp,""); break;
			case 0x93:
				fprintf(outfp,""); break;
			case 0x94:
				fprintf(outfp,""); break;
			case 0x95:
				fprintf(outfp,""); break;
			case 0x96:
				fprintf(outfp,""); break;
			case 0x97:
				fprintf(outfp,""); break;
			case 0x98:
				fprintf(outfp,""); break;
			case 0x99:
				fprintf(outfp,""); break;
			case 0x9a:
				fprintf(outfp,""); break;
			case 0x9b:
				fprintf(outfp,""); break;
			case 0x9c:
				fprintf(outfp,""); break;
			case 0x9d:
				fprintf(outfp,""); break;
			case 0x9e:
				fprintf(outfp,""); break;
			case 0x9f:
				fprintf(outfp,""); break;

			case 0xa0:
				fprintf(outfp,"@"); break;
			case 0xa1:
				fprintf(outfp,"B"); break;
			case 0xa2:
				fprintf(outfp,"u"); break;
			case 0xa3:
				fprintf(outfp,"v"); break;
			case 0xa4:
				fprintf(outfp,"A"); break;
			case 0xa5:
				fprintf(outfp,"E"); break;
			case 0xa6:
				fprintf(outfp,""); break;
			case 0xa7:
				fprintf(outfp,"@"); break;
			case 0xa8:
				fprintf(outfp,"B"); break;
			case 0xa9:
				fprintf(outfp,"D"); break;
			case 0xaa:
				fprintf(outfp,"F"); break;
			case 0xab:
				fprintf(outfp,"H"); break;
			case 0xac:
				fprintf(outfp,""); break;
			case 0xad:
				fprintf(outfp,""); break;
			case 0xae:
				fprintf(outfp,""); break;
			case 0xaf:
				fprintf(outfp,"b"); break;

			case 0xb0:
				fprintf(outfp,"["); break;
			case 0xb1:
				fprintf(outfp,"A"); break;
			case 0xb2:
				fprintf(outfp,"C"); break;
			case 0xb3:
				fprintf(outfp,"E"); break;
			case 0xb4:
				fprintf(outfp,"G"); break;
			case 0xb5:
				fprintf(outfp,"I"); break;
			case 0xb6:
				fprintf(outfp,"J"); break;
			case 0xb7:
				fprintf(outfp,"L"); break;
			case 0xb8:
				fprintf(outfp,"N"); break;
			case 0xb9:
				fprintf(outfp,"P"); break;
			case 0xba:
				fprintf(outfp,"R"); break;
			case 0xbb:
				fprintf(outfp,"T"); break;
			case 0xbc:
				fprintf(outfp,"V"); break;
			case 0xbd:
				fprintf(outfp,"X"); break;
			case 0xbe:
				fprintf(outfp,"Z"); break;
			case 0xbf:
				fprintf(outfp,"\"); break;

			case 0xc0:
				fprintf(outfp,"^"); break;
			case 0xc1:
				fprintf(outfp,"`"); break;
			case 0xc2:
				fprintf(outfp,"c"); break;
			case 0xc3:
				fprintf(outfp,"e"); break;
			case 0xc4:
				fprintf(outfp,"g"); break;
			case 0xc5:
				fprintf(outfp,"i"); break;
			case 0xc6:
				fprintf(outfp,"j"); break;
			case 0xc7:
				fprintf(outfp,"k"); break;
			case 0xc8:
				fprintf(outfp,"l"); break;
			case 0xc9:
				fprintf(outfp,"m"); break;
			case 0xca:
				fprintf(outfp,"n"); break;
			case 0xcb:
				fprintf(outfp,"q"); break;
			case 0xcc:
				fprintf(outfp,"t"); break;
			case 0xcd:
				fprintf(outfp,"w"); break;
			case 0xce:
				fprintf(outfp,"z"); break;
			case 0xcf:
				fprintf(outfp,"}"); break;

			case 0xd0:
				fprintf(outfp,"~"); break;
			case 0xd1:
				fprintf(outfp,""); break;
			case 0xd2:
				fprintf(outfp,""); break;
			case 0xd3:
				fprintf(outfp,""); break;
			case 0xd4:
				fprintf(outfp,""); break;
			case 0xd5:
				fprintf(outfp,""); break;
			case 0xd6:
				fprintf(outfp,""); break;
			case 0xd7:
				fprintf(outfp,""); break;
			case 0xd8:
				fprintf(outfp,""); break;
			case 0xd9:
				fprintf(outfp,""); break;
			case 0xda:
				fprintf(outfp,""); break;
			case 0xdb:
				fprintf(outfp,""); break;
			case 0xdc:
				fprintf(outfp,""); break;
			case 0xdd:
				fprintf(outfp,""); break;
			case 0xde:
				fprintf(outfp,"J"); break;
			case 0xdf:
				fprintf(outfp,"K"); break;

			case 0xe0:
				fprintf(outfp,""); break;
			case 0xe1:
				fprintf(outfp,""); break;
			case 0xe2:
				fprintf(outfp,""); break;
			case 0xe3:
				fprintf(outfp,""); break;
			case 0xe4:
				fprintf(outfp,""); break;
			case 0xe5:
				fprintf(outfp,""); break;
			case 0xe6:
				fprintf(outfp,""); break;
			case 0xe7:
				fprintf(outfp,""); break;
			case 0xe8:
				fprintf(outfp,""); break;
			case 0xe9:
				fprintf(outfp,""); break;
			case 0xea:
				fprintf(outfp,""); break;
			case 0xeb:
				fprintf(outfp,""); break;
			case 0xec:
				fprintf(outfp,""); break;
			case 0xed:
				fprintf(outfp,""); break;
			case 0xee:
				fprintf(outfp,""); break;
			case 0xef:
				fprintf(outfp,""); break;

			case 0xf0:
				fprintf(outfp,""); break;
			case 0xf1:
				fprintf(outfp,""); break;
			case 0xf2:
				fprintf(outfp,""); break;
			case 0xf3:
				fprintf(outfp,""); break;
			case 0xf4:
				fprintf(outfp,""); break;
			case 0xf5:
				fprintf(outfp,""); break;
			case 0xf6:
				fprintf(outfp,""); break;
			case 0xf7:
				fprintf(outfp,""); break;
			case 0xf8:
				fprintf(outfp,""); break;
			case 0xf9:
				fprintf(outfp,""); break;
			case 0xfa:
				fprintf(outfp,""); break;
			case 0xfb:
				fprintf(outfp,""); break;
			case 0xfc:
				fprintf(outfp,""); break;
			case 0xfd:
				fprintf(outfp,""); break;
			case 0xfe:
				fprintf(outfp,"@"); break;
			case 0xff:
				fprintf(outfp,"@"); break;

			default:
				break;
		}
	}

	return;
}

